unit DataBaseViewer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WorldContent, CharDataBase, StdCtrls, ComCtrls, ClassEdDialog,CharEdDialog,UnitInfoEdDialog,
  OtherDataBase,PlEditorDialog,ItemEdDialog,StatDB,GroupDataBase,UserGroupEd,QuestEditor;

type
  TDBViewer = class(TForm)
    Pages: TPageControl;
    CharDB: TTabSheet;
    CDBChars: TListBox;
    CDBUpdate: TButton;
    CDBEditBox: TGroupBox;
    CDBName: TLabel;
    CDBCharID: TLabel;
    CDBMana: TLabel;
    CDBHealth: TLabel;
    CDBExp: TLabel;
    CDBClassId: TLabel;
    CDBCreate: TButton;
    CDBHunit: TLabel;
    CharClassDB: TTabSheet;
    CCDBList: TListBox;
    CCDBUpdate: TButton;
    CCDBEditBox: TGroupBox;
    CCDBName: TLabel;
    CCDBID: TLabel;
    CCDBSpell1: TLabel;
    CCDBSpell2: TLabel;
    CCDBSpell3: TLabel;
    CCDBSpell4: TLabel;
    CCDBSpell5: TLabel;
    CCDBNew: TButton;
    CCDBEdit: TButton;
    CCDBUnit: TLabel;
    CDBEdit: TButton;
    UDB: TTabSheet;
    UDBList: TListBox;
    UDBUpdate: TButton;
    UDBCreate: TButton;
    UDBEditBox: TGroupBox;
    UDBEdit: TButton;
    UDBHealth: TLabel;
    UDBMana: TLabel;
    UDBRawCode: TLabel;
    UDBName: TLabel;
    UDBLvl: TLabel;
    UDBGiveExp: TLabel;
    UDBSpell1: TLabel;
    UDBSpell2: TLabel;
    UDBSpell3: TLabel;
    UDBSpell4: TLabel;
    UDBMissPer: TLabel;
    SpellPanel: TGroupBox;
    CDBSpell1: TLabel;
    CDBSpell2: TLabel;
    CDBSpell3: TLabel;
    CDBSpell4: TLabel;
    CDBSpell5: TLabel;
    CDBSpell6: TLabel;
    CCDBSpell6: TLabel;
    CDBOwner: TLabel;
    PlayerDB: TTabSheet;
    PDBUpdate: TButton;
    PDBNew: TButton;
    PDBList: TListBox;
    PDBEditBox: TGroupBox;
    PDBEdit: TButton;
    PDBLogin: TLabel;
    PDBEMail: TLabel;
    PDBPassword: TLabel;
    PDBChar1: TLabel;
    PDBChar2: TLabel;
    PDBChar3: TLabel;
    PDBChar4: TLabel;
    PDBChar5: TLabel;
    PDBChar6: TLabel;
    PDBChar7: TLabel;
    PDBChar8: TLabel;
    ItemPanel: TGroupBox;
    CDBItem1: TLabel;
    CDBItem2: TLabel;
    CDBItem3: TLabel;
    CDBItem4: TLabel;
    CDBItem5: TLabel;
    CDBItem6: TLabel;
    CDBUptime: TLabel;
    CDBSkillPoints: TLabel;
    UDBSpell5: TLabel;
    UDBSpell6: TLabel;
    UDBMinGold: TLabel;
    UDBMaxGold: TLabel;
    PDBDelete: TButton;
    IDB: TTabSheet;
    IDBBtnUpdateList: TButton;
    IDBNewItem: TButton;
    IDBList: TListBox;
    IDBEditBox: TGroupBox;
    IDBName: TLabel;
    IDBGold: TLabel;
    IDBCharges: TLabel;
    IDBClass: TLabel;
    IDBEdit: TButton;
    IDBRawCode: TLabel;
    CDBDelete: TButton;
    IDBNeedLevel: TLabel;
    IDBDelete: TButton;
    CDBGold: TLabel;
    CDBHonor: TLabel;
    CDBKillCount: TLabel;
    Label1: TLabel;
    CDBIsBan: TLabel;
    CDBIsMute: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    CDBSpell7: TLabel;
    CDBSpell8: TLabel;
    CDBSpell9: TLabel;
    CDBSpell10: TLabel;
    CDBSpell11: TLabel;
    SDB: TTabSheet;
    SDBList: TListBox;
    SDBInfoBox: TGroupBox;
    SDBDate: TLabel;
    SDBMaxOnline: TLabel;
    SDBMaxUptime: TLabel;
    UGDB: TTabSheet;
    UGDBList: TListBox;
    UGDBInfoBox: TGroupBox;
    UGDBName: TLabel;
    UGDBRules: TLabel;
    UGDBEdit: TButton;
    UGDBDelete: TButton;
    UGDBAdd: TButton;
    IDBHonor: TLabel;
    QuestDB: TTabSheet;
    QDBList: TListBox;
    QDBAdd: TButton;
    QDBInfoBox: TGroupBox;
    QDBEdit: TButton;
    QDBDiscription: TStaticText;
    QDBIconPath: TLabel;
    QDBStatus: TLabel;
    QDBDelete: TButton;
    QDBFinished: TLabel;
    QDBComplete: TLabel;
    QDBEffect: TLabel;
    QDBNeedLvl: TLabel;
    QDBNeedClass: TLabel;
    procedure CDBUpdateClick(Sender: TObject);
    procedure CDBCharsClick(Sender: TObject);
    procedure CCDBUpdateClick(Sender: TObject);
    procedure CCDBListClick(Sender: TObject);
    procedure CCDBEditClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CCDBNewClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure CDBEditClick(Sender: TObject);
    procedure CDBCreateClick(Sender: TObject);
    procedure UDBEditClick(Sender: TObject);
    procedure UDBListClick(Sender: TObject);
    procedure UDBUpdateClick(Sender: TObject);
    procedure UDBCreateClick(Sender: TObject);
    procedure PDBListClick(Sender: TObject);
    procedure PDBUpdateClick(Sender: TObject);
    procedure PDBEditClick(Sender: TObject);
    procedure PDBNewClick(Sender: TObject);
    procedure PagesChange(Sender: TObject);
    procedure PDBDeleteClick(Sender: TObject);
    procedure IDBListClick(Sender: TObject);
    procedure IDBBtnUpdateListClick(Sender: TObject);
    procedure IDBNewItemClick(Sender: TObject);
    procedure IDBEditClick(Sender: TObject);
    procedure CDBDeleteClick(Sender: TObject);
    procedure IDBDeleteClick(Sender: TObject);
    procedure SDBListClick(Sender: TObject);
    procedure UGDBListClick(Sender: TObject);
    procedure UGDBEditClick(Sender: TObject);
    procedure UGDBAddClick(Sender: TObject);
    procedure QDBAddClick(Sender: TObject);
    procedure QDBListClick(Sender: TObject);
    procedure QDBEditClick(Sender: TObject);
    procedure QDBDeleteClick(Sender: TObject);
  private
    current_classid: integer;
    current_charid: integer;
    current_unitid: integer;
    current_playerid: integer;
    current_itemid: integer;
    current_statid: integer;
    current_ugid: integer;
  public
    QDBItem: array [0..15] of TLabel;
    QDBNeed: array [0..4] of TLabel;
    function QDBItemCount: integer;
    procedure UpdateAllLists;
    procedure UpdateInfo;
    //Statistic Data Base
    procedure SDBUpdateList;
    procedure SDBUpdateStatInfo(id: integer);
    //Char Data Base
    procedure CDBUpdateList;
    procedure CDBUpdateCharInfo(id: integer);
    //Char Class Data Base
    procedure CCDBUpdateList;
    procedure CCDBUpdateClassInfo(id: integer);
    //Unit Data Base
    procedure UDBUpdateList;
    procedure UDBUpdateUnitInfo(id: integer);
    //Players Data Base
    procedure PDBUpdateList;
    procedure PDBUpdatePlayerInfo(id: integer);
    //Item Data Base
    procedure IDBUpdateList;
    procedure IDBUpdateItemInfo(id: integer);
    //User Group Data Base
    procedure UGDBUpdateList;
    procedure UGDBUpdateUGInfo(id: integer);
    //Quest Data Base
    procedure QDBUpdateList;
    procedure QDBUpdateQInfo(id: integer);
  end;

  function SecToTimeString(time: integer): string;

var
  DBViewer: TDBViewer;

implementation

uses Main;

{$R *.dfm}

function SecToTimeString(time: integer): string;
 var s,m,h: integer;
begin
 s:= time mod 60;
 time:= time div 60;
 m:= time mod 60;
 time:= time div 60;
 h:= time;
 Result:= IntToStr(h)+' h '+IntToStr(m)+' m '+IntToStr(s)+' s';
end;

procedure TDBViewer.FormCreate(Sender: TObject);
  var i: integer;
begin
 current_classid:= -1;
 current_charid:= -1;
 current_playerid:= -1;
 current_unitid:= -1;
 current_itemid:= -1;

 for i := 0 to 15 do
 begin
   QDBItem[i] := TLabel.Create(QDBInfoBox);
   with QDBItem[i] do
   begin
     Parent := QDBInfoBox;
     Left := 8;
     Top := 176 + i*16;
   end;
 end;
 for i := 0 to 4 do
 begin
  QDBNeed[i] := TLabel.Create(QDBInfoBox);
  with QDBNeed[i] do
  begin
    Parent := QDBInfoBox;
    Left := 8;
    Top := 176 + i*16;
  end;
 end;
end;

procedure TDBViewer.UpdateInfo;
begin
 CCDBUpdateClassInfo(current_charid);
 CCDBUpdateClassInfo(current_classid);
 UDBUpdateUnitInfo(current_unitid);
 PDBUpdatePlayerInfo(current_playerid);
 IDBUpdateItemInfo(current_itemid);
 SDBUpdateStatInfo(current_statid);
 UGDBUpdateUGinfo(current_ugid);
end;

procedure TDBViewer.UpdateAllLists;
begin
 CDBUpdateList;
 CCDBUpdateList;
 UDBUpdateList;
 PDBUpdateList;
 IDBUpdateList;
 SDBUpdateList;
 UGDBUpdateList;
 QDBUpdateList;
end;

procedure TDBViewer.CDBUpdateList;
 var i: integer;
begin
 CDBChars.Clear;
 for i:= 0 to ChDataBase.charcount-1 do
  CDBChars.Items.Add(ChDataBase.chars[i].name);
end;

procedure TDBViewer.CDBUpdateCharInfo(id: integer);
 var lc: TCharA;
begin
 current_charid:= id;
 CDBEditBox.Visible:= true;
 lc:= ChDataBase.chars[id];
 CDBCharID.Caption:= 'Char ID: '+IntToStr(lc.charid);
 CDBName.Caption:= 'Name: '+lc.name+' ('+GroupList[lc.UGlvl].name+')';
 CDBHealth.Caption:= 'Health: '+IntToStr(lc.health);
 CDBMana.Caption:= 'Mana: '+IntToStr(lc.mana);
 CDBExp.Caption:= 'Exp: '+IntToStr(lc.exp)+' ('+IntToStr(ExpToLevel(lc.exp))+')';
 CDBUpTime.Caption:= 'Uptime: '+SecToTimeString(lc.uptime);
 CDBSkillPoints.Caption:= 'Skill Points: '+IntToStr(lc.skillpoints);
 CDBGold.Caption := 'Gold: '+IntToStr(lc.gold);
 CDBHonor.Caption := 'Honor: '+IntToStr(lc.Honor);
 CDBKillCount.Caption := 'Kill Count: '+IntToStr(lc.killCount);
 if lc.ban then
  CDBIsBan.Caption := 'Baned on '+SecToTimeString(lc.banTime)
 else
  CDBIsBan.Caption := 'Not ban';
 CDBIsBan.Hint := lc.banDisc;
 CDBIsBan.ShowHint := true;
 if lc.mute then
  CDBIsMute.Caption := 'Muted on '+SecToTimeString(lc.muteTime)
 else
  CDBIsMute.Caption := 'Not mute';
 if (lc.classid >= 0) and (lc.classid < ChClassDataBase.classcount) then
  CDBClassID.Caption:= 'ClassID: '+IntToStr(lc.classid)+ ' ('+ChClassDataBase.classs[lc.classid].name+')'
 else
  CDBClassID.Caption:= 'ClassID: '+IntToStr(lc.classid)+' (not found)';
 CDBItem1.Caption:= 'Item 1: '+lc.ItemRC[0]+' ('+ItmDataBase.ItemsRaw[lc.ItemRC[0]].name+')';
 CDBItem2.Caption:= 'Item 2: '+lc.ItemRC[1]+' ('+ItmDataBase.ItemsRaw[lc.ItemRC[1]].name+')';
 CDBItem3.Caption:= 'Item 3: '+lc.ItemRC[2]+' ('+ItmDataBase.ItemsRaw[lc.ItemRC[2]].name+')';
 CDBItem4.Caption:= 'Item 4: '+lc.ItemRC[3]+' ('+ItmDataBase.ItemsRaw[lc.ItemRC[3]].name+')';
 CDBItem5.Caption:= 'Item 5: '+lc.ItemRC[4]+' ('+ItmDataBase.ItemsRaw[lc.ItemRC[4]].name+')';
 CDBItem6.Caption:= 'Item 6: '+lc.ItemRC[5]+' ('+ItmDataBase.ItemsRaw[lc.ItemRC[5]].name+')';
 CDBHunit.Caption:= 'HUNIT: '+IntToStr(lc.HUnit);
 if (lc.owner >= 0) and (lc.owner < AcDataBase.AccountCount) then
  CDBOwner.Caption:= 'Owner: '+IntToStr(lc.owner)+' ('+AcDataBase.Accounts[lc.owner].login+')'
 else
  CDBOwner.Caption:= 'Owner: not found account';
 CDBSpell1.Caption:= 'Spell 1: '+lc.spells[0].rawcode+'('+IntToStr(lc.spells[0].lvl)+')';
 CDBSpell2.Caption:= 'Spell 2: '+lc.spells[1].rawcode+'('+IntToStr(lc.spells[1].lvl)+')';
 CDBSpell3.Caption:= 'Spell 3: '+lc.spells[2].rawcode+'('+IntToStr(lc.spells[2].lvl)+')';
 CDBSpell4.Caption:= 'Spell 4: '+lc.spells[3].rawcode+'('+IntToStr(lc.spells[3].lvl)+')';
 CDBSpell5.Caption:= 'Spell 5: '+lc.spells[4].rawcode+'('+IntToStr(lc.spells[4].lvl)+')';
 CDBSpell6.Caption:= 'Spell 6: '+lc.spells[5].rawcode+'('+IntToStr(lc.spells[5].lvl)+')';
 CDBSpell7.Caption:= 'Spell 7: '+lc.spells[6].rawcode+'('+IntToStr(lc.spells[6].lvl)+')';
 CDBSpell8.Caption:= 'Spell 8: '+lc.spells[7].rawcode+'('+IntToStr(lc.spells[7].lvl)+')';
 CDBSpell9.Caption:= 'Spell 9: '+lc.spells[8].rawcode+'('+IntToStr(lc.spells[8].lvl)+')';
 CDBSpell10.Caption:= 'Spell 10: '+lc.spells[9].rawcode+'('+IntToStr(lc.spells[9].lvl)+')';
 CDBSpell11.Caption:= 'Spell 11: '+lc.spells[10].rawcode+'('+IntToStr(lc.spells[10].lvl)+')';
end;

procedure TDBViewer.CDBUpdateClick(Sender: TObject);
begin
 CDBUpdateList;
end;

procedure TDBViewer.CDBCharsClick(Sender: TObject);
 var i: integer;
begin
 i:= CDBChars.ItemIndex;
 if i < 0 then
 begin
  CDBEditBox.Visible:= false;
  exit;
 end;
 i:= ChDataBase.FindCharByName(CDBChars.Items[i]);
 if i < 0 then exit;
 CDBUpdateCharInfo(i);
end;

procedure TDBViewer.SDBUpdateList;
 var i: integer;
begin
 SDBList.Clear;
 for i:= 0 to StatisticDB.Count-1 do
  if i in [0..1] then
   case i of
    0: SDBList.Items.Add('Max Uptime');
    1: SDBList.Items.Add('Max Online');
   end else
    with StatisticDB.Items[i].Date do
     SDBList.Items.Add(IntToStr(day)+'.'+IntToStr(month)+'.'+IntToStr(year));
end;

procedure TDBViewer.SDBUpdateStatInfo(id: integer);
begin
 with StatisticDB.Items[id] do
 begin
  with Date do
   SDBDate.Caption := IntToStr(day)+'.'+IntToStr(month)+'.'+IntToStr(year);
  SDBMaxOnline.Caption := 'Max Online: '+IntToStr(maxonline);
  SDBMaxUptime.Caption := 'Max Uptime: '+SecToTimeString(maxuptime);
 end;
end;

procedure TDBViewer.CCDBUpdateClassInfo(id: integer);
begin
 current_classid:= id;
 if current_classid < 0 then exit;
 CCDBEditBox.Visible:= true;
 with ChClassDataBase.classs[id] do
 begin
  CCDBName.Caption:= 'Name: '+name;
  CCDBID.Caption:= 'Class ID: '+IntToStr(id);
  CCDBSpell1.Caption:= 'Spell 1: '+spell[0];
  CCDBSpell2.Caption:= 'Spell 2: '+spell[1];
  CCDBSpell3.Caption:= 'Spell 3: '+spell[2];
  CCDBSpell4.Caption:= 'Spell 4: '+spell[3];
  CCDBSpell5.Caption:= 'Spell 5: '+spell[4];
  CCDBSpell6.Caption:= 'Spell 6: '+spell[5]; 
  CCDBUnit.Caption:= 'Unit: '+urc;
 end;
end;

procedure TDBViewer.CCDBUpdateList;
 var i: integer;
begin
 CCDBList.Items.Clear;
 for i:= 0 to ChClassDataBase.classcount-1 do
  CCDBList.Items.Add(ChClassDataBase.classs[i].name);
end;

procedure TDBViewer.CCDBUpdateClick(Sender: TObject);
begin
 CCDBUpdateList;
end;

procedure TDBViewer.CCDBListClick(Sender: TObject);
 var i: integer;
begin
 i:= CCDBList.ItemIndex;
 if i < 0 then
 begin
  CCDBEditBox.Visible:= false;
  exit;
 end;
 CCDBUpdateClassInfo(i);
end;

procedure TDBViewer.CCDBEditClick(Sender: TObject);
 var i: integer;
begin
 if current_classid < 0 then exit;
 ClassEditor.ClearData;
 with ChClassDataBase.classs[current_classid] do
 begin
  ClassEditor.Spell1.Text:= spell[0];
  ClassEditor.Spell2.Text:= spell[1];
  ClassEditor.Spell3.Text:= spell[2];
  ClassEditor.Spell4.Text:= spell[3];
  ClassEditor.Spell5.Text:= spell[4];
  ClassEditor.Spell6.Text:= spell[5];
  ClassEditor.Name.Text:= name;
  ClassEditor.UnitRawCode.Text:= urc;
 end;
 i:= ClassEditor.Execute;
 case i of
  mrOK:
   with ChClassDataBase.classs[current_classid] do
   begin
    name:= ClassEditor.Name.Text;
    urc:= ClassEditor.UnitRawCode.Text;
    spell[0]:= ClassEditor.Spell1.Text;
    spell[1]:= ClassEditor.Spell2.Text;
    spell[2]:= ClassEditor.Spell3.Text;
    spell[3]:= ClassEditor.Spell4.Text;
    spell[4]:= ClassEditor.Spell5.Text;
    spell[5]:= ClassEditor.Spell6.Text;
    CCDBUpdateClassInfo(current_classid);
    CCDBUpdateList;
   end;
 end;
end;

procedure TDBViewer.CCDBNewClick(Sender: TObject);
begin
 ChClassDataBase.AddClassChar('new_class','','','','','','Hpal');
 CCDBUpdateList;
end;

procedure TDBViewer.FormActivate(Sender: TObject);
begin
 UpdateAllLists;
end;

procedure TDBViewer.CDBEditClick(Sender: TObject);
 var i: integer;
     lb: boolean;
begin
 if current_charid < 0 then exit;
 CharEditor.ClearData;
 with ChDataBase.chars[current_charid] do
 begin
  CharEditor.Name.Text:= name;
  CharEditor.OwnerList.Clear;
  CharEditor.OwnerList.Items.Text:= AcDataBase.GetPlayersList;
  CharEditor.OwnerList.ItemIndex:= owner;
  CharEditor.OwnerID.Value:= owner;
  CharEditor.OwnerID.MaxValue:= AcDataBase.AccountCount-1;
  CharEditor.CharClass.Items.Text:= ChClassDataBase.GetClassList;
  CharEditor.CharClass.ItemIndex:= classid;
  CharEditor.Health.Value:= health;
  CharEditor.Mana.Value:= mana;
  CharEditor.Exp.Value:= exp;
  for i:= 0 to GroupCount-1 do
   CharEditor.UserGroupLvl.Items.Add(GroupList[i].name);
  CharEditor.UserGroupLvl.ItemIndex := UGlvl;
  CharEditor.IsBan.Checked := Ban;
  CharEditor.IsMute.Checked := Mute;
  CharEditor.BanTime.Value := banTime;
  CharEditor.MuteTime.Value:= muteTime;
  CharEditor.BanDisc.Text := banDisc;
  CharEditor.Spell1.Text:= spells[0].rawcode;
  CharEditor.Spell2.Text:= spells[1].rawcode;
  CharEditor.Spell3.Text:= spells[2].rawcode;
  CharEditor.Spell4.Text:= spells[3].rawcode;
  CharEditor.Spell5.Text:= spells[4].rawcode;
  CharEditor.Spell6.Text:= spells[5].rawcode;
  CharEditor.Spell7.Text:= spells[6].rawcode;
  CharEditor.Spell8.Text:= spells[7].rawcode;
  CharEditor.Spell9.Text:= spells[8].rawcode;
  CharEditor.Spell10.Text:= spells[9].rawcode;
  CharEditor.Spell11.Text:= spells[10].rawcode;
  CharEditor.SpellLvl1.Value:= spells[0].lvl;
  CharEditor.SpellLvl2.Value:= spells[1].lvl;
  CharEditor.SpellLvl3.Value:= spells[2].lvl;
  CharEditor.SpellLvl4.Value:= spells[3].lvl;
  CharEditor.SpellLvl5.Value:= spells[4].lvl;
  CharEditor.SpellLvl6.Value:= spells[5].lvl;
  CharEditor.SpellLvl7.Value:= spells[6].lvl;
  CharEditor.SpellLvl8.Value:= spells[7].lvl;
  CharEditor.SpellLvl9.Value:= spells[8].lvl;
  CharEditor.SpellLvl10.Value:= spells[9].lvl;
  CharEditor.SpellLvl11.Value:= spells[10].lvl;
 end;
 i:= CharEditor.Execute;
 case i of
  mrOk:
   with ChDataBase.chars[current_charid] do
   begin
    if owner <> CharEditor.OwnerID.Value then
     AcDataBase.DeleteChar(owner,charid);
    owner:= CharEditor.OwnerID.Value;
    AcDataBase.AddChar(owner,current_charid);
    name:= CharEditor.Name.Text;
    classid:= CharEditor.CharClass.ItemIndex;
    health:= CharEditor.Health.Value;
    mana:= CharEditor.Mana.Value;
    exp:= CharEditor.Exp.Value;
    lb := ban;
    ban:= CharEditor.IsBan.Checked;
    banTime:= CharEditor.BanTime.Value;
    banDisc:= CharEditor.BanDisc.Text;
    if not ban then
    begin
     banTime := 0;
     banDisc := '';
    end;
    if (lb <> ban) and ban then
    begin
     SendInfoEMail(IEMailBan,account.email,ChDataBase.chars[current_charid],ChDataBase.chars[current_charid].Account);
     if status then
     begin
      client.Send('servermsg("      '+SecToTimeString(banTime)+'  : '+banDisc+'")');
      client.Socket.Close;
     end;
    end;
    mute:= CharEditor.IsMute.Checked;
    muteTime:= CharEditor.MuteTime.Value;
    if not mute then
     muteTime := 0;
    UGlvl := CharEditor.UserGroupLvl.ItemIndex;
    spells[0].rawcode:= CharEditor.Spell1.Text;
    spells[1].rawcode:= CharEditor.Spell2.Text;
    spells[2].rawcode:= CharEditor.Spell3.Text;
    spells[3].rawcode:= CharEditor.Spell4.Text;
    spells[4].rawcode:= CharEditor.Spell5.Text;
    spells[5].rawcode:= CharEditor.Spell6.Text;
    spells[6].rawcode:= CharEditor.Spell7.Text;
    spells[7].rawcode:= CharEditor.Spell8.Text;
    spells[8].rawcode:= CharEditor.Spell9.Text;
    spells[9].rawcode:= CharEditor.Spell10.Text;
    spells[10].rawcode:= CharEditor.Spell11.Text;
    spells[0].lvl:= CharEditor.SpellLvl1.Value;
    spells[1].lvl:= CharEditor.SpellLvl2.Value;
    spells[2].lvl:= CharEditor.SpellLvl3.Value;
    spells[3].lvl:= CharEditor.SpellLvl4.Value;
    spells[4].lvl:= CharEditor.SpellLvl5.Value;
    spells[5].lvl:= CharEditor.SpellLvl6.Value;
    spells[6].lvl:= CharEditor.SpellLvl7.Value;
    spells[7].lvl:= CharEditor.SpellLvl8.Value;
    spells[8].lvl:= CharEditor.SpellLvl9.Value;
    spells[9].lvl:= CharEditor.SpellLvl10.Value;
    spells[10].lvl:= CharEditor.SpellLvl11.Value;
    CDBUpdateCharInfo(current_charid);
    CDBUpdateList;
   end;
 end;//case
end;

procedure TDBViewer.CDBCreateClick(Sender: TObject);
begin
 if ChClassDataBase.classcount <= 0 then
 begin
  MessageDlg('      ',mtError,[mbOK],0);
  exit;
 end;
 ChDataBase.AddChar('new_char',0,0);
 CDBUpdateList;
end;

procedure TDBViewer.UDBEditClick(Sender: TObject);
 var i: integer;
begin
 if current_unitid < 0 then exit;
 UnitEditor.ClearData;
 with UnDataBase.units[current_unitid] do
 begin
  UnitEditor.Name.Text:= name;
  UnitEditor.RawCode.Text:= rawcode;
  UnitEditor.MaxHealth.Value:= maxhealth;
  UnitEditor.MaxMana.Value:= maxmana;
  UnitEditor.Level.Value:= level;
  UnitEditor.GiveExp.Value:= giveexp;
  UnitEditor.MissPer.Value:= missper;
  UnitEditor.Spell1.Text:= spell[0];
  UnitEditor.Spell2.Text:= spell[1];
  UnitEditor.Spell3.Text:= spell[2];
  UnitEditor.Spell4.Text:= spell[3];
  UnitEditor.Spell5.Text:= spell[4];
  UnitEditor.Spell6.Text:= spell[5];
  UnitEditor.MinGold.Value:= mingold;
  UnitEditor.MaxGold.Value:= maxgold;
 end;
 i:= UnitEditor.Execute;
 case i of
  mrOK:
   with UnDataBase.units[current_unitid] do
   begin
    name:= UnitEditor.Name.Text;
    rawcode:= UnitEditor.RawCode.Text;
    maxhealth:= UnitEditor.MaxHealth.Value;
    maxmana:= UnitEditor.MaxMana.Value;
    level:= UnitEditor.Level.Value;
    giveexp:= UnitEditor.GiveExp.Value;
    missper:= UnitEditor.MissPer.Value;
    spell[0]:= UnitEditor.Spell1.Text;
    spell[1]:= UnitEditor.Spell2.Text;
    spell[2]:= UnitEditor.Spell3.Text;
    spell[3]:= UnitEditor.Spell4.Text;
    spell[4]:= UnitEditor.Spell5.Text;
    spell[5]:= UnitEditor.Spell6.Text;
    mingold:= UnitEditor.MinGold.Value;
    maxgold:= UnitEditor.MaxGold.Value;
    UDBUpdateUnitInfo(current_unitid);
    UDBUpdateList;
   end;
 end;
end;

procedure TDBViewer.UDBUpdateList;
 var i: integer;
begin
 UDBList.Clear;
 for i:= 0 to UnDataBase.count-1 do
  UDBList.Items.Add(UnDataBase.Units[i].name);
end;

procedure TDBViewer.UDBUpdateUnitInfo(id: integer);
begin
 current_unitid:= id;
 if current_unitid < 0 then exit;
 UDBEditBox.Visible:= true;
 with UnDataBase.units[id] do
 begin
  UDBName.Caption:= 'Name: '+name;
  UDBrawCode.Caption:= 'Raw code: '+rawcode;
  UDBHealth.Caption:= 'Max health: '+IntToStr(maxhealth);
  UDBMana.Caption:= 'Max mana: '+IntToStr(maxmana);
  UDBLvl.Caption:= 'Level: '+IntToStr(level);
  UDBGiveExp.Caption:= 'Give Exp: '+IntToStr(GiveExp);
  UDBMissPer.Caption:= 'Miss percent: '+IntToStr(missper);
  UDBSpell1.Caption:= 'Spell 1: '+spell[0];
  UDBSpell2.Caption:= 'Spell 2: '+spell[1];
  UDBSpell3.Caption:= 'Spell 3: '+spell[2];
  UDBSpell4.Caption:= 'Spell 4: '+spell[3];
  UDBSpell5.Caption:= 'Spell 5: '+spell[4];
  UDBSpell6.Caption:= 'Spell 6: '+spell[5];
  UDBMinGold.Caption:= 'Min Gold: '+IntToStr(mingold);
  UDBMaxGold.Caption:= 'Max Gold: '+IntToStr(maxgold);
 end;
end;

procedure TDBViewer.UDBListClick(Sender: TObject);
 var i: integer;
begin
 i:= UDBList.ItemIndex;
 if i < 0 then
 begin
  UDBEditBox.Visible:= false;
  exit;
 end;
 UDBUpdateUnitInfo(i);
end;

procedure TDBViewer.UDBUpdateClick(Sender: TObject);
begin
 UDBUpdateList;
end;

procedure TDBViewer.UDBCreateClick(Sender: TObject);
begin
 UnDataBase.Add('new unit','nill');
 UDBUpdateList;
end;

procedure TDBViewer.PDBUpdateList;
 var i: integer;
begin
 PDBList.Clear;
 for i:= 0 to AcDataBase.AccountCount-1 do
  PDBList.Items.Add(AcDataBase.Accounts[i].login);
end;

procedure TDBViewer.PDBUpdatePlayerInfo(id: integer);
 var labels: array [0..7] of TLabel;
     i,j: integer;
begin
 current_playerid:= id;
 if current_playerid < 0 then exit;
 PDBEditBox.Visible:= true;
 with AcDataBase.Accounts[id] do
 begin
  PDBLogin.Caption:= 'Login: '+login;
  PDBEmail.Caption:= 'EMail: '+email;
  PDBPassword.Caption:= 'Password: '+password;
  labels[0]:= PDBChar1;
  labels[1]:= PDBChar2;
  labels[2]:= PDBChar3;
  labels[3]:= PDBChar4;
  labels[4]:= PDBChar5;
  labels[5]:= PDBChar6;
  labels[6]:= PDBChar7;
  labels[7]:= PDBChar8;
  for i:= 0 to 7 do
   if chars[i] >= 0 then
   begin
    j := ChDataBase.FindCharByCharID(chars[i]);
    labels[i].Caption:= 'Char '+IntToStr(i+1)+': '+IntToStr(chars[i])+' ('+ChDataBase.chars[j].name+')'
   end
   else
    labels[i].Caption:= 'Char '+IntToStr(i+1)+' is not found';
 end;
end;

procedure TDBViewer.PDBListClick(Sender: TObject);
 var i: integer;
begin
 i:= PDBList.ItemIndex;
 if i < 0 then
 begin
  PDBEditBox.Visible:= false;
  exit;
 end;
 PDBUpdatePlayerInfo(i);
end;

procedure TDBViewer.PDBUpdateClick(Sender: TObject);
begin
 PDBUpdateList;
end;

procedure TDBViewer.PDBEditClick(Sender: TObject);
 var i,j: integer;
     last: string;
begin
 if current_playerid < 0 then exit;
 PlayerEditor.ClearData;
 with AcDataBase.Accounts[current_playerid] do
 begin
  PlayerEditor.Login.Text:= login;
  PlayerEditor.Password.Text:= password;
  PlayerEditor.EMail.Text := email;
  for i := 0 to ChDataBase.charcount-1 do
   PlayerEditor.CharList1.Items.Add(ChDataBase.chars[i].name);
  PlayerEditor.CharList2.Items.AddStrings(PlayerEditor.CharList1.Items);
  PlayerEditor.CharList3.Items.AddStrings(PlayerEditor.CharList1.Items);
  PlayerEditor.CharList4.Items.AddStrings(PlayerEditor.CharList1.Items);
  PlayerEditor.CharList5.Items.AddStrings(PlayerEditor.CharList1.Items);
  PlayerEditor.CharList6.Items.AddStrings(PlayerEditor.CharList1.Items);
  PlayerEditor.CharList7.Items.AddStrings(PlayerEditor.CharList1.Items);
  PlayerEditor.CharList8.Items.AddStrings(PlayerEditor.CharList1.Items);
  j:= ChDataBase.charcount;
  PlayerEditor.CharID1.MaxValue:= j;
  PlayerEditor.CharID2.MaxValue:= j;
  PlayerEditor.CharID3.MaxValue:= j;
  PlayerEditor.CharID4.MaxValue:= j;
  PlayerEditor.CharID5.MaxValue:= j;
  PlayerEditor.CharID6.MaxValue:= j;
  PlayerEditor.CharID7.MaxValue:= j;
  PlayerEditor.CharID8.MaxValue:= j;
  PlayerEditor.CharID1.Value:= chars[0];
  PlayerEditor.CharID2.Value:= chars[1];
  PlayerEditor.CharID3.Value:= chars[2];
  PlayerEditor.CharID4.Value:= chars[3];
  PlayerEditor.CharID5.Value:= chars[4];
  PlayerEditor.CharID6.Value:= chars[5];
  PlayerEditor.CharID7.Value:= chars[6];
  PlayerEditor.CharID8.Value:= chars[7];
 end;
 i:= PlayerEditor.Execute;
 case i of
  mrOK: with AcDataBase.Accounts[current_playerid] do
        begin
         login:= PlayerEditor.Login.Text;
         last := password;
         password:= PlayerEditor.Password.Text;
         if last <> password then
          Main.SendInfoEMail(IEMailChangePass,email,nil,AcDataBase.Accounts[current_playerid]);
         last := email;
         email:= PlayerEditor.EMail.Text;
         if last <> email then
          Main.SendInfoEMail(IEMailChangeMail,last,nil,AcDataBase.Accounts[current_playerid]);
         chars[0]:= PlayerEditor.CharID1.Value;
         chars[1]:= PlayerEditor.CharID2.Value;
         chars[2]:= PlayerEditor.CharID3.Value;
         chars[3]:= PlayerEditor.CharID4.Value;
         chars[4]:= PlayerEditor.CharID5.Value;
         chars[5]:= PlayerEditor.CharID6.Value;
         chars[6]:= PlayerEditor.CharID7.Value;
         chars[7]:= PlayerEditor.CharID8.Value;
         for j:= 0 to 7 do
          if chars[j] >= 0 then
           ChDataBase.chars[chars[j]].owner:= current_playerid;
        end;
  end;
  PDBUpdateList;
  PDBUpdatePlayerInfo(current_playerid);
end;

procedure TDBViewer.PDBNewClick(Sender: TObject);
begin
 AcDataBase.AddAccount('new_acc','qwerty','nil@mail.ru');
 PDBUpdateList;
end;

procedure TDBViewer.PagesChange(Sender: TObject);
begin
 UpdateInfo;
end;

procedure TDBViewer.PDBDeleteClick(Sender: TObject);
 var id: integer;
begin
 id:= PDBList.ItemIndex;
 if id < 0 then exit;
 AcDataBAse.RemoveAccount(id);
 PDBUpdateList;
end;

procedure TDBViewer.IDBUpdateItemInfo(id: integer);
 var i: integer;
     s: string;
begin
 current_itemid:= id;
 if id < 0 then exit;
 IDBEditBox.Visible:= true;
 with ItmDataBase.items[id] do
 begin
  IDBName.Caption:= 'Name: '+name;
  IDBRawCode.Caption:= 'Raw Code: '+rawcode;
  IDBGold.Caption:= 'Gold cost: '+IntToStr(gold);
  IDBHonor.Caption:= 'Honor cost: '+IntToStr(honor);
  IDBNeedLevel.Caption:= 'Need Level: '+IntToStr(NeedLevel);
  if useable then
   IDBCharges.Caption:= 'Charges max: true ('+IntToStr(charges)+')'
  else
   IDBCharges.Caption:= 'Charges max: false';
  s:= 'For Class: ';
  for i:= 0 to 9 do
   if forclass[i] then
    if i < ChClassDataBase.classcount then
     s:= s + ChClassDataBase.classs[i].name+'; ';
  IDBClass.Caption:= s;
 end;
end;

procedure TDBViewer.IDBUpdateList;
 var i: integer;
begin
 IDBList.Clear;
 for i:= 0 to ItmDataBase.count-1 do
  IDBList.Items.Add(ItmDataBase.Items[i].name);
end;

procedure TDBViewer.IDBListClick(Sender: TObject);
begin
 IDBUpdateItemInfo(IDBList.ItemIndex);
end;

procedure TDBViewer.IDBBtnUpdateListClick(Sender: TObject);
begin
 IDBUpdateList;
end;

procedure TDBViewer.IDBNewItemClick(Sender: TObject);
begin
 ItmDataBase.Add('new itm','nil');
 IDBUpdateList;
 IDBList.ItemIndex := IDBList.Items.Count-1;
end;

procedure TDBViewer.IDBEditClick(Sender: TObject);
 var flags: array [0..9] of TCheckBox;
     i: integer;
begin
 if current_itemid < 0 then exit;
 ItemEditor.ClearData;
 with ItmDataBase.items[current_itemid] do
 begin
  flags[0]:= ItemEditor.ForClass1;
  flags[1]:= ItemEditor.ForClass2;
  flags[2]:= ItemEditor.ForClass3;
  flags[3]:= ItemEditor.ForClass4;
  flags[4]:= ItemEditor.ForClass5;
  flags[5]:= ItemEditor.ForClass6;
  flags[6]:= ItemEditor.ForClass7;
  flags[7]:= ItemEditor.ForClass8;
  flags[8]:= ItemEditor.ForClass9;
  flags[9]:= ItemEditor.ForClass10;
  for i:= 0 to 9 do
  begin
   if i < ChClassDataBase.classcount then
   begin
    flags[i].Checked:= forclass[i];
    flags[i].Caption:= ChClassDataBase.classs[i].name;
    flags[i].Visible := true;
   end else flags[i].Visible := false;
  end;
  ItemEditor.ItemName.Text:= name;
  ItemEditor.RawCode.Text:= rawcode;
  ItemEditor.IsCharges.Checked:= useable;
  ItemEditor.MaxCharges.Value:= charges;
  ItemEditor.Gold.Value:= gold;
  ItemEditor.Honor.Value:= honor;
  ItemEditor.NeedLevel.Value := NeedLevel;
  ItemEditor.Str.Value := str;
  ItemEditor.Agi.Value := agi;
  ItemEditor.Int.Value := int;
  ItemEditor.Stamina.Value := Stamina;
  ItemEditor.Res.Value := Resistance;
  ItemEditor.Armor.Value := Armor;
  ItemEditor.HolyRes.Value := MagicResist.value[mtHoly];
  ItemEditor.ShadowRes.Value := MagicResist.value[mtUnholy];
  ItemEditor.FireRes.Value := MagicResist.value[mtFire];
  ItemEditor.WaterRes.Value := MagicResist.value[mtWater];
  ItemEditor.NatureRes.Value := MagicResist.value[mtNature];
  ItemEditor.EarthRes.Value := MagicResist.value[mtEarth];
  ItemEditor.Parr.Value := Parr;
  ItemEditor.Absorb.Value := Absorb;
  ItemEditor.Damage.Value := Damage;
  ItemEditor.DblDamage.Value := DblDamage;
  ItemEditor.Punch.Value := Punch;
  ItemEditor.Accuracy.Value := Accuracy;
  ItemEditor.Speed.Value := Speed;
  ItemEditor.MagicDamage.Value := MagicDamage;
  ItemEditor.magicDblDamage.Value := MagicDblDmg;
  ItemEditor.MagicPower.Value := MagicPower;
  ItemEditor.MagicCast.Value := MagicCast;
 end;
 case ItemEditor.Execute of
  mrOK: begin
         with ItmDataBase.items[current_itemid] do
         begin
          for i:= 0 to 9 do
           forclass[i]:= flags[i].Checked;
          gold:= ItemEditor.Gold.Value;
          honor:= ItemEditor.Honor.Value;
          useable:= ItemEditor.IsCharges.Checked;
          charges:= ItemEditor.MaxCharges.Value;
          rawcode:= ItemEditor.RawCode.Text;
          name:= ItemEditor.ItemName.Text;
          NeedLevel := ItemEditor.NeedLevel.Value;
          str := ItemEditor.Str.Value;
          agi := ItemEditor.Agi.Value;
          int := ItemEditor.Int.Value;
          Stamina := ItemEditor.Stamina.Value;
          Resistance := ItemEditor.Res.Value;
          Armor := ItemEditor.Armor.Value;
          MagicResist.value[mtHoly] := ItemEditor.HolyRes.Value;
          MagicResist.value[mtUnholy] := ItemEditor.ShadowRes.Value;
          MagicResist.value[mtFire] := ItemEditor.FireRes.Value;
          MagicResist.value[mtWater] := ItemEditor.WaterRes.Value;
          MagicResist.value[mtNature] := ItemEditor.NatureRes.Value;
          MagicResist.value[mtEarth] := ItemEditor.EarthRes.Value;
          Parr := ItemEditor.Parr.Value;
          Absorb := ItemEditor.Absorb.Value;
          Damage := ItemEditor.Damage.Value;
          DblDamage := ItemEditor.DblDamage.Value;
          Punch := ItemEditor.Punch.Value;
          Accuracy := ItemEditor.Accuracy.Value;
          Speed := ItemEditor.Speed.Value;
          MagicDamage := ItemEditor.MagicDamage.Value;
          MagicDblDmg := ItemEditor.magicDblDamage.Value;
          MagicPower := ItemEditor.MagicPower.Value;
          MagicCast := ItemEditor.MagicCast.Value;
         end;
         IDBUpdateItemInfo(current_itemid);
         IDBUpdateList;
        end;
 end;
end;

procedure TDBViewer.CDBDeleteClick(Sender: TObject);
begin
 if current_charid < 0 then exit;
 ChDataBase.RemoveChar(current_charid);
 CDBUpdateList;
end;

procedure TDBViewer.IDBDeleteClick(Sender: TObject);
begin
 if not ItmDataBase.RemoveItem(current_itemid) then
 begin
  ShowMessage('Error!!! Can not DELETE item info');
  Exit;
 end;
 IDBUpdateList;
end;

procedure TDBViewer.SDBListClick(Sender: TObject);
 var i: integer;
begin
 i := SDBList.ItemIndex;
 if i < 0 then Exit;
 current_statid := i;
 SDBUpdateStatInfo(i);
end;

procedure TDBViewer.UGDBUpdateUgInfo(id: integer);
 var s: string;
begin
 current_ugid := id;
 UGDBName.Caption := 'Name: '+GroupList[id].name;
 s := '';
 if GroupList[id].ban then s := s + 'ban; ';
 if GroupList[id].unban then s := s + 'unban; ';
 if GroupList[id].mute then s := s + 'mute; ';
 if GroupList[id].unmute then s := s + 'unmute; ';
 if GroupList[id].send then s := s + 'send; ';
 if GroupList[id].mgs then s := s + 'mgs; ';
 if GroupList[id].teleport then s := s + 'teleport; ';
 if GroupList[id].execute then s := s + 'execute; ';
 if GroupList[id].banView then s := s + 'ban view; ';
 UGDBRules.Caption := 'Rules: '+s;
end;

procedure TDBViewer.UGDBUpdateList;
 var i: integer;
begin
 UGDBList.Clear;
 for i:= 0 to GroupCount-1 do
  UGDBList.Items.Add(GroupList[i].name);
end;

procedure TDBViewer.UGDBListClick(Sender: TObject);
 var i: integer;
begin
 i := UGDBList.ItemIndex;
 if i < 0 then Exit;
 UGDBUpdateUgInfo(i);
end;

procedure TDBViewer.UGDBEditClick(Sender: TObject);
begin
 with GroupList[current_ugid] do
 begin
   UserGroupEditor.GroupName.Text := name;
   UserGroupEditor.IsBan.Checked := ban;
   UserGroupEditor.IsUnban.Checked := unban;
   UserGroupEditor.IsMute.Checked := mute;
   UserGroupEditor.IsUnmute.Checked := unmute;
   UserGroupEditor.IsMgs.Checked := mgs;
   UserGroupEditor.IsExecute.Checked := execute;
   UserGroupEditor.IsTeleport.Checked := teleport;
   UserGroupEditor.IsSend.Checked := send;
   UserGroupeditor.IsBanView.Checked := banView;
   if UserGroupEditor.Execute = mrOK then
   begin
      name := UserGroupEditor.GroupName.Text;
      ban := UserGroupEditor.IsBan.Checked;
      unban := UserGroupEditor.Isunban.Checked;
      mute := UserGroupEditor.IsMute.Checked;
      unmute := UserGroupEditor.IsUnmute.Checked;
      mgs := UserGroupEditor.IsMgs.Checked;
      execute := UserGroupEditor.IsExecute.Checked;
      teleport := UserGroupEditor.IsTeleport.Checked;
      send := UserGroupEditor.IsSend.Checked;
      banView := UserGroupEditor.IsBanView.Checked;
      UGDBUpdateUGInfo(current_ugid);
      UGDBUpdateList;
   end;
 end;
end;

procedure TDBViewer.UGDBAddClick(Sender: TObject);
begin
 GroupDataBase.Add('New group');
 UGDBUpdateList;
end;

procedure TDBViewer.QDBAddClick(Sender: TObject);
  var i: integer;
begin
 i := QuestDataBase.Add('New quest');
 QDBUpdateList();
 QDBList.ItemIndex := i;
 QDBUpdateQInfo(i);
end;

procedure TDBViewer.QDBUpdateList;
  var i: integer;
begin
  QDBList.Clear;
  for i := 0 to QuestDataBase.Count-1 do
    QDBList.Items.Add(QuestDataBase.List[i].title);
end;

procedure TDBViewer.QDBUpdateQInfo(id: integer);
  var i,count: integer;
      s: string;
      lastVis: integer;
begin
  with QuestDataBase.List[id] do
  begin
    QDBInfoBox.Visible := true;
    QDBInfoBox.Caption := title;
    QDBDiscription.Caption := 'Discription: '+discription;
    QDBIconPath.Caption := 'Icon path: '+iconPath;
    QDBStatus.Caption := 'Data Table status path: '+statusPath;
    QDBFinished.Caption := 'Data Table finish path: '+finishedPath;
    QDBComplete.Caption := 'Data Table complete path: '+completePath;
    QDBEffect.Caption := 'Local Data Table effect save path: '+effectPath;
    QDBNeedLvl.Caption := 'Need lvl: '+IntToStr(needLvl);
    s := '';
    for i := 0 to ChClassDataBase.classcount-1 do
      if needClass[i] then
        s := s + ChClassDataBase.classs[i].name + '; ';
    QDBNeedClass.Caption := 'Need class: '+s;
    count := 0;
    lastVis := -1;
    for i := 0 to 15 do
    begin
      QDBItem[i].Visible := qItem[i] <> '';
      if lastVis >= 0 then
        QDBItem[i].Top := QDBItem[lastVis].Top + 16;
      if QDBItem[i].Visible then
      begin
        inc(count);
        lastVis := i;
      end;
      QDBItem[i].Caption := 'Quest item['+IntToStr(i)+']: '+qItem[i];
    end;
    for i := 0 to 4 do
    begin
      QDBNeed[i].Visible := NeedPathList[i] <> '';
      QDBNeed[i].Caption := 'Quest need['+IntToStr(i)+']: '+NeedPathList[i];
      if (lastVis >= 0) then
        QDBNeed[i].Top := QDBItem[lastVis].Top + (i+1)*16
      else
        if i = 0 then
          QDBNeed[i].Top := 176
        else
          QDBNeed[i].Top := QDBNeed[i-1].Top + 16;
    end;
    QDBInfoBox.Visible := true;
  end;
end;

procedure TDBViewer.QDBListClick(Sender: TObject);
begin
  QDBUpdateQInfo(QDBList.ItemIndex);
end;

procedure TDBViewer.QDBEditClick(Sender: TObject);
  var id,i: integer;
      return: TModalResult;
begin
  id := QDBList.ItemIndex;
  if id < 0 then exit;
  with QuestDataBase.List[id] do
  begin
    QuestEditorDialog.Title.Text := title;
    QuestEditorDialog.Discription.Text := discription;
    QuestEditorDialog.IconPath.Text := iconPath;
    QuestEditorDialog.Status.Text := statusPath;
    QuestEditorDialog.Finish.Text := finishedPath;
    QuestEditorDialog.Complete.Text := completePath;
    QuestEditorDialog.NeedLvl.Value := needLvl;
    QuestEditorDialog.Effect.Text := effectPath;
    for i := 0 to 4 do
      QuestEditorDialog.Need[i].Text := needPathList[i];
    for i := 0 to 9 do
    begin
      QuestEditorDialog.ForClass[i].Checked := needClass[i];
      QuestEditorDialog.ForClass[i].Enabled := i < ChClassDataBase.classcount;
      if i < ChClassDataBase.classcount then
        QuestEditorDialog.ForClass[i].Caption := ChClassDataBase.classs[i].name;
    end;
    for i := 0 to 15 do
      QuestEditorDialog.Item[i].Text := qItem[i];
  end;
  case QuesteditorDialog.Execute of
    mrOK: begin
            with QuestDataBase.List[id] do
            begin
              title := QuestEditorDialog.Title.Text;
              discription := QuestEditorDialog.Discription.Text;
              iconPath := QuestEditorDialog.IconPath.Text;
              statusPath := QuestEditorDialog.Status.Text;
              finishedPath := QuestEditorDialog.Finish.Text;
              completePath := QuestEditorDialog.Complete.Text;
              effectPath := QuestEditorDialog.Effect.Text;
              needLvl := QuestEditorDialog.NeedLvl.Value;
              for i := 0 to 4 do
                needPathList[i] := QuestEditorDialog.Need[i].Text;
              for i := 0 to 9 do
                needClass[i] := QuestEditorDialog.ForClass[i].Checked;
              for i := 0 to 15 do
                qItem[i] := QuestEditorDialog.Item[i].Text;
            end;
          end;
  end;
  QDBUpdateList;
  QDBList.ItemIndex := id;
  QDBUpdateQInfo(id);
end;

procedure TDBViewer.QDBDeleteClick(Sender: TObject);
 var id: integer;
begin
  id := QDBList.ItemIndex;
  if id < 0 then Exit;
  QuestDataBase.Delete(id);
  QDBUpdateList;
  if id-1 < 0 then
  begin
    QDBInfoBox.Visible := false;
    Exit;
  end;
  QDBList.ItemIndex := id-1;
  QDBUpdateQInfo(id-1);
end;

function TDBViewer.QDBItemCount: integer;
  var i: integer;
begin
  Result := 0;
  for Result := 0 to 14 do
    if not QDBItem[i].Visible then
      break;
end;

end.
