unit EMailSending;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CheckLst, GroupDataBase, CharDataBase;

type
  TMsgSendForm = class(TForm)
    MsgSubject: TEdit;
    Label1: TLabel;
    MsgText: TMemo;
    SendBtn: TButton;
    ChkGroupList: TCheckListBox;
    CancelBtn: TButton;
    Label2: TLabel;
    procedure SendBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure UpdateList;
  end;

var
  MsgSendForm: TMsgSendForm;

implementation

{$R *.dfm}

uses Main;

procedure TMsgSendForm.UpdateList;
  var i: integer;
begin
  MsgText.Text := '';
  MsgSubject.Text := '';
  ChkGroupList.Clear;
  for i:= 0 to GroupDataBase.GroupCount - 1 do
    ChkGroupList.AddItem(GroupList[i].name, nil);
end;

procedure TMsgSendForm.SendBtnClick(Sender: TObject);
  var i,j: integer;
      b: boolean;
begin
  //Check data
  if MsgSubject.Text = '' then
  begin
    ShowMessage('     ');
    Exit;
  end;
  if MsgText.Text = '' then
  begin
    ShowMessage('     ');
    Exit;
  end;
  b := false;
  for i := 0 to GroupCount - 1 do
    b := b or ChkGroupList.Checked[i];
  if not b then
  begin
    ShowMessage('    ');
    Exit;
  end;
  //Send
  for i := 0 to AcDataBase.AccountCount - 1 do
  begin
    b := false;
    for j := 0 to GroupCount - 1 do
      if ChkGroupList.Checked[j] then
      begin
        b := b or AcDataBase.IsAccountInGroup(i, j);
        if b then
          break;
      end;
    if b then
      MainForm.SendEMail('forgottenlandserver@yandex.ru','FLS@ya.ru',AcDataBase.Accounts[i].email,MsgText.Text,MsgSubject.Text);
  end;
end;

end.
