program Server;

uses
  Forms,
  SysUtils,
  Main in 'Main.pas' {MainForm},
  MGScriptNatives in 'MGScriptNatives.pas',
  WorldContent in 'WorldContent.pas',
  CharDataBase in 'CharDataBase.pas',
  DataBaseViewer in 'DataBaseViewer.pas' {DBViewer},
  Connections in 'Connections.pas',
  mgscript in 'MGScript.pas',
  CharEdDialog in 'CharEdDialog.pas' {CharEditor},
  ClassEdDialog in 'ClassEdDialog.pas' {ClassEditor},
  OtherDataBase in 'OtherDataBase.pas',
  UnitInfoEdDialog in 'UnitInfoEdDialog.pas' {UnitEditor},
  ServerChat in 'ServerChat.pas' {ServerChatForm},
  ScriptLog in 'ScriptLog.pas' {ScriptLogForm},
  PlEditorDialog in 'PlEditorDialog.pas' {PlayerEditor},
  ItemEdDialog in 'ItemEdDialog.pas' {ItemEditor},
  StatDB in 'StatDB.pas',
  GroupDataBase in 'GroupDataBase.pas',
  UserGroupEd in 'UserGroupEd.pas' {UserGroupEditor},
  AntiCheatSystem in 'AntiCheatSystem.pas',
  QuestEditor in 'QuestEditor.pas' {QuestEditorDialog},
  Utils in 'Utils.pas',
  MGSCore in 'MGSCore.pas',
  MGSApi in 'MGSApi.pas',
  EMailSending in 'EMailSending.pas' {MsgSendForm};

{$R *.res}

begin
  WorldContent.appPath:= ExtractFilePath(Application.ExeName);
  LoadSettings;
  Application.Initialize;
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(TDBViewer, DBViewer);
  Application.CreateForm(TCharEditor, CharEditor);
  Application.CreateForm(TClassEditor, ClassEditor);
  Application.CreateForm(TUnitEditor, UnitEditor);
  Application.CreateForm(TServerChatForm, ServerChatForm);
  Application.CreateForm(TScriptLogForm, ScriptLogForm);
  Application.CreateForm(TPlayerEditor, PlayerEditor);
  Application.CreateForm(TItemEditor, ItemEditor);
  Application.CreateForm(TUserGroupEditor, UserGroupEditor);
  Application.CreateForm(TQuestEditorDialog, QuestEditorDialog);
  Application.CreateForm(TMsgSendForm, MsgSendForm);
  MainForm.LoadExSettings;
  Application.Run;
end.
