library WinSockToWar;

uses
  SysUtils,
  Classes,
  WinSock,
  jass_types,
  nAPI;

{$R *.res}

function d_addr(IPaddr : string) : Cardinal;
var
  pa: PChar;
  sa: TInAddr;
  Host: PHostEnt;
begin
  Result:=inet_addr(PChar(IPaddr));
  if Result=INADDR_NONE then
  begin
    host:=GetHostByName(PChar(IPaddr));
    if Host = nil then
      exit
    else
    begin
      pa := Host^.h_addr_list^;
      sa.S_un_b.s_b1 := pa[0];
      sa.S_un_b.s_b2 := pa[1];
      sa.S_un_b.s_b3 := pa[2];
      sa.S_un_b.s_b4 := pa[3];
      with TInAddr(sa).S_un_b do
        Result:=inet_addr(PChar(IntToStr(Ord(s_b1)) + '.' + IntToStr(Ord(s_b2)) + '.' +
        IntToStr(Ord(s_b3)) + '.' + IntToStr(Ord(s_b4))));
    end;
  end;
end;


begin
end.
 