unit DataBaseViewer;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TDBViewer = class(TForm)
    Chars: TListBox;
    Label1: TLabel;
    CharID: TLabel;
    CharName: TLabel;
    CharHealth: TLabel;
    CharMana: TLabel;
    CharInfo: TGroupBox;
    CharPos: TLabel;
    procedure CharsClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure Open;
  end;

var
  DBViewer: TDBViewer;

implementation

{$R *.dfm}

uses main;

procedure TDBViewer.CharsClick(Sender: TObject);
 var i: integer;
begin
 i:= Chars.ItemIndex;
 if i < 0 then exit;
 with database.Chars[i] do
 begin
  Self.CharID.Caption:= 'ID: '+IntToStr(charid);
  CharName.Caption:= ': '+ name;
  CharHealth.Caption:= ': '+IntToStr(Health);
  CharMana.Caption:= ': '+IntToStr(Mana);
  CharInfo.Caption:= name + ' (id: '+IntToStr(charid)+')';
  CharPos.Caption:= ' ('+IntToStr(x)+';'+IntToStr(y)+')';
 end;
 CharInfo.Visible:= true;
end;

procedure TDBViewer.Open;
 var i: integer;
begin
 Chars.Items.Clear;
 for i:= 0 to database.charcount-1 do
  Chars.Items.Add(database.Chars[i].name);

 Visible:= false;
 Visible:= true;
end;

end.
