unit players;

interface

uses ScktComp;

type
 TPlayer = class
  name: string;
  charid,id: integer;
  Socket: TCustomWinSocket;
  constructor Create(n: string; s: TCustomWinSocket; c: integer);
  destructor Destroy;
end;

var
 allplayers: array of TPlayer;
 playercount: integer;

implementation

constructor TPlayer.Create(n: string; s: TCustomWinSocket; c: integer);
begin
 inherited Create();
 allplayers[playercount]:= Self;
 id:= playercount;
 inc(playercount);
 name:= n;
 socket:= s;
 charid:= c;
end;

destructor TPlayer.Destroy;
begin
 dec(playercount);
 allplayers[id]:= allplayers[playercount];
 allplayers[id].id:= id;
 socket:= nil;
 charid:= 0;
end;

end.
