unit CharEdDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin;

type
  TCharEditor = class(TForm)
    Label1: TLabel;
    Name: TEdit;
    Label2: TLabel;
    CharClass: TComboBox;
    Health: TSpinEdit;
    Mana: TSpinEdit;
    Exp: TSpinEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label10: TLabel;
    OK: TButton;
    Cancel: TButton;
    Spell1: TEdit;
    Spell2: TEdit;
    Spell3: TEdit;
    Spell6: TEdit;
    Spell5: TEdit;
    Spell4: TEdit;
    SpellLvl1: TSpinEdit;
    SpellLvl2: TSpinEdit;
    SpellLvl3: TSpinEdit;
    SpellLvl4: TSpinEdit;
    SpellLvl5: TSpinEdit;
    SpellLvl6: TSpinEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    OwnerList: TComboBox;
    OwnerID: TSpinEdit;
    Label3: TLabel;
    Spell7: TEdit;
    SpellLvl7: TSpinEdit;
    Label17: TLabel;
    Spell8: TEdit;
    SpellLvl8: TSpinEdit;
    Label18: TLabel;
    Spell9: TEdit;
    SpellLvl9: TSpinEdit;
    Label19: TLabel;
    Spell10: TEdit;
    SpellLvl10: TSpinEdit;
    Label20: TLabel;
    Spell11: TEdit;
    SpellLvl11: TSpinEdit;
    IsBan: TCheckBox;
    BanTime: TSpinEdit;
    Label21: TLabel;
    BanDisc: TEdit;
    IsMute: TCheckBox;
    MuteTime: TSpinEdit;
    Label22: TLabel;
    Label23: TLabel;
    UserGroupLvl: TComboBox;
    procedure OwnerListKeyPress(Sender: TObject; var Key: Char);
    procedure OwnerListChange(Sender: TObject);
    procedure OwnerIDChange(Sender: TObject);
  private
    { Private declarations }
  public
    function Execute: TModalResult;
    procedure ClearData; 
  end;

var
  CharEditor: TCharEditor;

implementation

uses CharDataBase;

{$R *.dfm}

{ TCharEditor }

procedure TCharEditor.ClearData;
begin
 Name.Text:= '';
 OwnerID.Value:= 0;
 CharClass.ItemIndex:= -1;
 UserGroupLvl.Clear;
 Health.Value:= 0;
 Mana.Value:= 0;
 Exp.Value:= 0;
 IsBan.Checked := false;
 IsMute.Checked := false;
 BanTime.Value := 0;
 BanDisc.Text := '';
 MuteTime.Value := 0;
 Spell1.Text:= '';
 Spell2.Text:= '';
 Spell3.Text:= '';
 Spell4.Text:= '';
 Spell5.Text:= '';
 Spell6.Text:= '';
 Spell7.Text:= '';
 Spell8.Text:= '';
 Spell9.Text:= '';
 Spell10.Text:= '';
 Spell11.Text:= '';
 SpellLvl1.Value:= 0;
 SpellLvl2.Value:= 0;
 SpellLvl3.Value:= 0;
 SpellLvl4.Value:= 0;
 SpellLvl5.Value:= 0;
 SpellLvl6.Value:= 0;
 SpellLvl7.Value:= 0;
 SpellLvl8.Value:= 0;
 SpellLvl9.Value:= 0;
 SpellLvl10.Value:= 0;
 SpellLvl11.Value:= 0;
end;

function TCharEditor.Execute: TModalResult;
begin
 try
  Result:= ShowModal;
 finally
 end;
end;

procedure TCharEditor.OwnerListKeyPress(Sender: TObject; var Key: Char);
begin
 Key:= #0;
end;

procedure TCharEditor.OwnerListChange(Sender: TObject);
begin
 OwnerID.Value:= OwnerList.ItemIndex;
end;

procedure TCharEditor.OwnerIDChange(Sender: TObject);
begin
 OwnerList.ItemIndex:= OwnerID.Value;
end;

end.
