unit GroupDataBase;

//       

interface

 uses SysUtils;
 
 type
  TUserGroup = record
    name: string [255]; // 
    //
    ban: boolean; //
    banView: boolean; // 
    unban: boolean; //
    mute: boolean; // 
    unmute: boolean; // 
    send: boolean; // 
    mgs: boolean; // 
    teleport: boolean; //    
    execute: boolean; //  
  end;

var
  GroupList: array of TUserGroup;
  GroupCount: integer = 0;

procedure Save;
function Load(path: string): boolean;
procedure Add(name: string);

implementation

 var Fpath: string;

procedure Add(name: string);
 var i: integer;
begin
  i := GroupCount;
  inc(groupCount);
  SetLength(GroupList,GroupCount);
  GroupList[i].name := name;
end;

function Load(path: string): boolean;
 var f: file of TUserGroup;
     i: integer;
begin
 Result := false;
 Fpath := path;
 if not FileExists(path) then Exit;
 AssignFile(f,path);
 Reset(f);
 while not EoF(f) do
 begin
  i := GroupCount;
  inc(groupCount);
  SetLength(GroupList,GroupCount);
  Read(f,GroupList[i]);
 end;
 CloseFile(f);
 Result := true;
end;

procedure Save;
 var f: file of TUserGroup;
     i: integer;
begin
 AssignFile(f,Fpath);
 Rewrite(f);
 for i:= 0 to GroupCount-1 do
  Write(f,GroupList[i]);
 CloseFile(f);
end;

end.
