unit UnitInfoEdDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Spin;

type
  TUnitEditor = class(TForm)
    Name: TEdit;
    RawCode: TEdit;
    Spell1: TEdit;
    Spell2: TEdit;
    Spell3: TEdit;
    Spell4: TEdit;
    MaxHealth: TSpinEdit;
    MaxMana: TSpinEdit;
    Level: TSpinEdit;
    GiveExp: TSpinEdit;
    MissPercent: TTrackBar;
    MissPer: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    OK: TButton;
    Cancel: TButton;
    Label12: TLabel;
    Spell5: TEdit;
    Label13: TLabel;
    Spell6: TEdit;
    MinGold: TSpinEdit;
    MaxGold: TSpinEdit;
    Label14: TLabel;
    Label15: TLabel;
    procedure MissPercentChange(Sender: TObject);
    procedure MissPerChange(Sender: TObject);
  private
    { Private declarations }
  public
   procedure ClearData;
   function Execute: TModalResult;
  end;

var
  UnitEditor: TUnitEditor;

implementation

{$R *.dfm}

procedure TUnitEditor.ClearData;
begin
 Name.Text:= '';
 RawCode.Text:= '';
 MaxHealth.Value:= 1;
 MaxMana.Value:= 0;
 Level.Value:= 1;
 GiveExp.Value:= 0;
 MissPer.Value:= 0;
 Spell1.Text:= '';
 Spell2.Text:= '';
 Spell3.Text:= '';
 Spell4.Text:= '';
 Spell5.Text:= '';
 Spell6.Text:= '';
 MinGold.Value:= 0;
 MaxGold.Value:= 0;
end;

function TUnitEditor.Execute: TModalResult;
begin
 try
  Result:= ShowModal;
 finally
 end;
end;

procedure TUnitEditor.MissPercentChange(Sender: TObject);
begin
 MissPer.Value:= MissPercent.Position;
end;

procedure TUnitEditor.MissPerChange(Sender: TObject);
begin
 MissPercent.Position:= MissPer.Value;
end;

end.
