unit ActionDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TActionDialog = class(TForm)
    ActionList: TComboBox;
    Label1: TLabel;
    FrmOK: TButton;
    FrmCancel: TButton;
    Param1: TEdit;
    Param2: TEdit;
    OpenFile: TButton;
    OpenDialog: TOpenDialog;
    UberTip: TLabel;
    procedure OpenFileClick(Sender: TObject);
    procedure ActionListChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


  function Execute: boolean;

var
  ActionDialog: TActionDialog;

implementation

{$R *.dfm}

function Execute: boolean;
begin
 with ActionDialog do
 begin
  FrmOk.Enabled := false;
  ActionList.ItemIndex := -1;
  ActionList.Text := ' ';
  Param1.Text := 'Param1';
  Param2.Text := 'Param2';
  Result:= ShowModal = mrOK;
 end;
end;

procedure TActionDialog.OpenFileClick(Sender: TObject);
begin
 if OpenDialog.Execute then
  Param1.Text := OpenDialog.FileName;
end;

procedure TActionDialog.ActionListChange(Sender: TObject);
 var id : integer;
begin
 id := ActionList.ItemIndex;
 FrmOk.Enabled := id >= 0;
 case id of
  0: Ubertip.Caption := '   . Param1 -  ; Param2 -   (  %client)';
  1: Ubertip.Caption := ' 2      . Param1 -  ; Param2 -    (  %client%)';
 end;
end;

end.
