unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Menus, ScktComp, MGScript, MGScriptNatives,
  CharDataBase, DataBaseViewer, connections, worldcontent, OtherDataBase,
  ServerChat, IniFiles, CoolTrayIcon, StatDB, GroupDataBase, IdMessage,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdMessageClient, IdSMTP, IdCoder, IdCoder3to4, IdCoderMIME,AntiCheatSystem,
  EMailSending, XPMan, MGSApi, MGSCore;

type
  TMainForm = class(TForm)
    ServerSocket: TServerSocket;
    MainMenu: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    LogList: TMemo;
    ClearLog: TButton;
    MainTimer: TTimer;
    SaveLog: TButton;
    StatBox: TGroupBox;
    TimeUp: TLabel;
    Online: TLabel;
    Connections: TLabel;
    ScriptBox: TGroupBox;
    ScriptText: TMemo;
    ScriptRun: TButton;
    ScriptParams: TEdit;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    PopupMenu1: TPopupMenu;
    Exit1: TMenuItem;
    Open1: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    TrayIcon: TCoolTrayIcon;
    N9: TMenuItem;
    IsLogOn: TCheckBox;
    Version: TLabel;
    PlayerOnlineList: TListBox;
    IdEncoderMIME1: TIdEncoderMIME;
    IdSMTP: TIdSMTP;
    SaveDialog1: TSaveDialog;
    EMail1: TMenuItem;
    XPManifest1: TXPManifest;
    procedure MainTimerTimer(Sender: TObject);
    procedure ClearLogClick(Sender: TObject);
    procedure SaveLogClick(Sender: TObject);
    procedure ServerSocketAccept(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocketClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocketClientError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure N2Click(Sender: TObject);
    procedure ServerSocketClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ScriptRunClick(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure N6Click(Sender: TObject);
    procedure TrayIconDblClick(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure IsLogOnClick(Sender: TObject);
    procedure EMail1Click(Sender: TObject);
  private
    { Private declarations }
  public
    stime: string;
    uptime: integer;
    procedure TrayAction(suspend: boolean);
    procedure SendMsg(msg: string; notSocket: TCustomWinSocket);
    procedure SendMSgTo(msg: string; Socket: TCustomWinSocket; utf8: boolean);
    procedure AddLog(from,msg: string; Socket: TCustomWinSocket);
    procedure LoadExSettings;
    procedure SendEMail(login,password,toEMail,msg,subject: string);
  end;

type
 TMsgThread = class(TThread)
  constructor Create(Socket: TCustomWinSocket; msg: string);
  protected
   procedure Execute; override;
  private
   FMsg: string;
   FSocket: TCustomWinSocket;
 end;
 TPathList = record
  script: string;
  log: string;
  database: string;
  datatable: string;
  dialogtable: string;
  root: string;
 end;
 TCharSortStruct = record
  charid: integer;
  value: integer;
 end;
 TCharSortArray = array of TCharSortStruct;

procedure SendAllPlayers(msg: string; notSock: TCustomWinSocket);
procedure SendAllPlayersOnLoc(msg: string; locId: byte; notSock: TCustomWinSocket);
procedure SendAllPlayersOnRange(msg: string; locId: byte; x,y,range: real; notSock: TCustomWinSocket);
procedure LoadSettings;
procedure SendInfoEMail(info: integer; toEMail: string; data: TObject; account: TAccountB; newPass: string);

const
 IEMailBan        = 0; //  
 IEMailPassReturn = 1; //    
 IEMailChangeMail = 2; //    
 IEMailChangePass = 3; //   

const
  AdminKey = 'QWERTYitISadminKEY!';

var
  MainForm: TMainForm;
  AdmConn: TConnection = nil;
  AdmPass: string [16] = 'GoodPass';
  logon_on: boolean = true;
  pathlist: TPathList;
  WhiteList: TStrings;

const
 c_time_up = 3;
 ServerVersion: string = '0.87.0 [alpha]';
 VersionData: string = '26.02.2012';

implementation

uses ScriptLog, Math;

{$R *.dfm}


procedure qSortCharArray(var List: TCharSortArray; isdown: boolean);
  procedure Sort(l,r: integer);
   var
    i,j,x : integer;
    loc: TCharSortStruct;
  begin
    i := l; j := r; x := List[random(r-l+1)+l].value;
    repeat
      if isdown then
      begin
        while List[i].value > x do inc(i);
        while x > List[j].value do inc(j);
      end else begin
        while List[i].value < x do inc(i);
        while x < List[j].value do inc(j);
      end;
      if i <= j then
      begin
        if isdown then begin
          if List[i].value < List[j].value then begin loc := List[i]; List[i] := List[j]; List[j] := loc; end;
        end else begin
          if List[i].value > List[j].value then begin loc := List[i]; List[i] := List[j]; List[j] := loc; end;
        end;
        inc(i); dec(j);
      end;
    until i >= j;
    if l < j then Sort(l,j);
    if i < r then Sort(i,r);
  end;

begin
  Randomize;
  Sort(Low(List),High(List));
end;


procedure CopyFieldInArray(var List: TCharSortArray; field,sorttype: string);
   var i: integer;
       len,c: integer;
       down,needSort: boolean;
       //Sorttype Samples
       // type:getcount
       // down:10
       // up:15
       // nil:all
       function GetSortType(out isdown: boolean; out count: integer): boolean;
        var i: integer;
            s1,s2: string;
       begin
        i := Pos(':',sorttype);
        s1 := Copy(sorttype,1,i); //sort direction
        s2 := Copy(sorttype, i+1, Length(sorttype)-1); //count
        Result := true;
        if s1 = 'down' then isdown := true else
        if s1 = 'up' then isdown := false else
        Result := false;
        if s2 = 'all' then count := High(List)-Low(List)+1 else
         count := StrToInt(s2);
       end;
  begin
    needSort:= GetSortType(down,len);
    c := ChdataBase.charcount;
    if (not needSort) and (len < ChDataBase.charcount) then c := len;
    SetLength(List,c);
    for i:= 0 to c-1 do
    begin
      List[i].charid := ChDataBase.chars[i].charid;
      List[i].value := StrToInt(ChDataBase.chars[i].GetField(field));
    end;
    if needSort then
    begin
      qSortCharArray(List,down);
      List := Copy(List,0,len);
    end;
  end;

  function GetChDataBaseRequest(field,sort: string): TCharSortArray;
  begin
    CopyFieldInArray(Result,field,sort);
  end;


procedure LoadSettings;
 var ini: TIniFile;
     path: string;
begin
 path:= ExtractFilePath(Application.ExeName)+'settings.ini';
 ini:= TIniFile.Create(path);
 pathlist.script:= ini.ReadString('path','script','scripts/');
 pathlist.log:= ini.ReadString('path','log','logs/');
 pathlist.database:= ini.ReadString('path','database','');
 pathlist.root:= ini.ReadString('path','root','');
 pathlist.datatable:= ini.ReadString('path','datatable',pathlist.database+'\data');
 pathlist.dialogtable:= ini.ReadString('path','dialogtable','');
 ini.Destroy;
end;

procedure TMainForm.TrayAction(suspend: boolean);
begin
 if suspend then
  TrayIcon.HideMainForm
 else
  TrayIcon.ShowMainForm;
end;

function CheckEmail(email: string): boolean;
begin
 Result := true;
end;

function TimeToStr(t: integer): string;
begin
 Result:= IntToStr((t div 60) div 60)+':'+IntToStr((t div 60) mod 60)+':'+IntToStr(t mod 60);
end;

//==============================================================================
//Log Func
//

procedure TMainForm.AddLog(from,msg: string; Socket: TCustomWinSocket);
 var i: integer;
begin
 with LogList.Lines do
  if Socket = nil then
   Add('['+stime+']'+from+' -> local msg -> '+msg)
  else
  begin
   i:= FindConnectionS(Socket);
   if i < 0 then
    Add('['+stime+']'+from+' -> '+Socket.RemoteAddress+' -> '+msg)
   else
    Add('['+stime+']'+from+' -> '+Socket.RemoteAddress+' ('+allsocks[i].login+'\'+ConnTypeToStr(allsocks[i]._type)+') -> '+msg);
  end;
  LogList.Lines.SaveToFile(pathlist.log+'Server_log.txt');
end;

procedure TMainForm.ClearLogClick(Sender: TObject);
begin
 LogList.Clear;
end;

procedure TMainForm.SaveLogClick(Sender: TObject);
begin
 if SaveDialog1.Execute then
   LogList.Lines.SaveToFile(SaveDialog1.FileName);
end;

//==============================================================================
// Timer Func

function TimeToPer(time: integer): integer;
begin
 Result:= Round(time/60*100);
end;

procedure TMainForm.MainTimerTimer(Sender: TObject);
 var st: SystemTime;
     i: integer;
begin
 try
  //Game Time
  GetSystemTime(st);
  stime:= IntToStr(st.wHour+c_time_up)+':'+IntToStr(st.wMinute)+':'+IntToStr(st.wSecond);
  if ServerSocket.Active then
  begin
    inc(uptime);
    TUnitCyclesThread.Create;
    StatisticDB.UpdateData(uptime,PlayerOnlineList.Count);
    TimeUp.Caption:= ' : '+TimeToStr(uptime);
    Online.Caption:= '  : '+IntToStr(PlayerOnlineList.Count);
    Connections.Caption:= ': '+IntToStr(ServerSocket.Socket.ActiveConnections);
   //Char Data Base Process
    if ChDataBase <> nil then
     for i:= 0 to ChDataBase.charcount-1 do
      with ChDataBase.chars[i] do
      begin
       //UP time
       if status then
        inc(uptime);
       //Ban Process
       if ban then
       begin
        dec(banTime);
        if banTime <= 0 then
         ban := false;
       end;
       //Mute Process
       if mute then
       begin
        dec(muteTime);
        if muteTime <= 0 then
         mute := false;
       end;
    end;
    if uptime mod 300 = 0 then
    begin
     if AcDataBase <> nil then
      AcDataBase.QSave;
     if ChDataBase <> nil then
      ChDataBase.Save(ChDataBase._path);
     if StatisticDB <> nil then
      StatisticDB.Save;
     AddLog('MainTimer','Data Base saved',nil);
    end;
    if uptime mod 60 = 0 then
     SendAllPlayers('time('+IntToStr(st.wHour+c_time_up)+'.'+IntToStr(TimeToPer(st.wMinute))+')',nil);
  end;
 except
  on E: Exception do AddLog('MainTimer','exception '+E.ClassName+' with message '+E.Message,nil);
 end;
end;

//==============================================================================
//SERVER BLOCK
//==============================================================================

procedure SendAllPlayers(msg: string; notSock: TCustomWinSocket);
 var i: integer;
begin
 for i:= 0 to sockcount-1 do
  if allsocks[i]._type = ctGameClient then
   if allsocks[i].customvalue >= 0 then
    if allsocks[i].Socket <> notSock then
     allSocks[i].Socket.SendText(AnsiToUTF8(msg)+newPack);
end;

procedure SendAllPlayersOnRange(msg: string; locId: byte; x,y,range: real; notSock: TCustomWinSocket);
 var i,j: integer;
     char: TCharA;
begin
  for i:= 0 to sockcount-1 do
   if (allsocks[i]._type = ctGameClient) and (allsocks[i].Socket <> notSock) and (allsocks[i].customvalue >= 0) then
   begin
      j := allsocks[i].customvalue;
      if j >= 0 then
      begin
        char := chdataBase.chars[j];
        if (char.locid = locID) and ( SqRt((char.posx-x)*(char.posx-x)+(char.posy-y)*(char.posy-y)) <= range ) then
          allsocks[i].Send(msg);
      end;
   end;
end;

procedure SendAllPlayersOnLoc(msg: string; locId: byte; notSock: TCustomWinSocket);
 var i,j: integer;
     char: TCharA;
begin
 for i:= 0 to sockcount-1 do
  if allsocks[i]._type = ctGameClient then
   if allsocks[i].Socket <> notSock then
    if allsocks[i].customvalue >= 0 then
    begin
     j:= allsocks[i].customvalue;
     if j >= 0 then
     begin
      char:= ChDataBase.chars[j];
      if char.locid = locId then
        allsocks[i].Send(msg);
     end;
    end;
end;

{ TMsgThread }

constructor TMsgThread.Create(Socket: TCustomWinSocket; msg: string);
begin
 inherited Create(true);
 FSocket:= Socket;
 FMsg:= msg;
 FreeOnTerminate:= true;
 Resume;
end;

function GetWord(str: string): string;
 var i: integer;
begin
 Result:= '';
 for i:= 1 to Length(str) do
  if str[i] = ' ' then exit else Result:= Result+str[i];
end;

procedure CompileLine(line: string);
 var mgs: TMGScript;
begin
 mgs:= TMGScript.Create(line);
 mgs.Compile;
 mgs.Free;
end;

procedure GM_MessageProc(GMChar: TCharA; msg: string);
  var comname: string;
      params: string;
      par: array [1..10] of string;
      i: integer;
      char: TCharA;
  const
    notRules : string = '    ,    ';
begin
 comname := GetComName(msg);
 params := GetComParams(msg);
 if comname = '/ban' then
 begin
  if GMChar.UserGroup.ban then
  begin
    par[1] := GetComParam(params,1); //target name
    par[2] := GetComParam(params,2); //time (minut)
    par[3] := GetComParam(params,3); //discription
    i := ChDataBase.FindCharByName(par[1]);
    if i < 0 then Exit;
    char := ChDataBase.chars[i];
    if (StrToInt(par[2])*60 < char.banTime) and (not GMChar.UserGroup.unban) then
    begin
      GMChar.client.Send('servermsg("'+notRules+'")');
      Exit;
    end;
    char.ban := true;
    char.banTime := StrToInt(par[2])*60;
    char.banDisc := GMChar.name+': '+par[3];
    SendInfoEMail(IEMailBan,char.Account.email,char,char.Account, '');
    SendAllPlayers('servermsg("'+char.UserGroup.name+': '+GMChar.name+'   '+char.name+'  '+par[2]+'    '+par[3]+'")',nil);
    char.client.Socket.Close;
   end else
    GMChar.client.Send('servermsg("'+notRules+'")');
   Exit;
  end;
  if comname = '/banview' then
  begin
   if GMChar.UserGroup.banView then
   begin
    par[1] := GetComParam(params,1);
    i := ChDataBase.FindCharByName(par[1]);
    if i < 0 then exit;
    char := ChDataBase.chars[i];
    if char.ban then
    begin
     GMChar.client.Send('servermsg("Ban info for '+char.name+':")');
     GMChar.client.Send('servermsg("Time: '+SecToTimeString(char.banTime)+'")');
     GMChar.client.Send('servermsg("Reason: '+char.banDisc+'")');
    end else
     GMChar.client.Send('servermsg("'+char.name+' is not banned")');
   end else
    GMChar.client.Send('servermsg("'+notRules+'")');
   Exit;
  end;
  if comname = '/execute' then
  begin
    if GMChar.UserGroup.execute then
      CompileLine(params)
    else
      GMChar.client.Send('servermsg("'+notRules+'")');
   Exit;
  end;
  if comname = '/mgs' then
  begin
    if GMChar.UserGroup.mgs then
    begin
      par[1] := GetComParam(params,1);
      par[2] := GetComParam(params,2);
      par[3] := GetComParam(params,3);
      RunMGScript(par[1],par[2],par[3]);
    end else
      GMChar.client.Send('servermsg("'+notRules+'")');
    Exit;
 end;
 if comname = '/send' then
 begin
   if GMChar.UserGroup.send then
    SendAllPlayers('servermsg("'+params+'")',nil)
   else
    GMChar.client.Send('servermsg("'+notRules+'")');
   Exit;
 end;
 if comname = '/unmute' then
 begin
   if GMChar.UserGroup.unmute then
   begin
    par[1] := GetComParam(params,1); //target name
    i := ChDataBase.FindCharByName(par[1]);
    if i < 0 then Exit;
    char := ChDataBase.chars[i];
    char.mute := false;
    char.muteTime := 0;
    char.client.Send('servermsg("'+GMChar.name+'       ');
   end else
    GMChar.client.Send('servermsg("'+notRules+'")');
  Exit;
 end;
 if comname = '/mute' then
 begin
  if GMChar.UserGroup.mute then
  begin
    par[1] := GetComParam(params,1); //target name
    par[2] := GetComParam(params,2); //time (minute)
    i := ChdataBase.FindCharByName(par[1]);
    if i < 0 then Exit;
    char := ChDataBase.chars[i];
    if (StrToInt(par[2])*60 < char.muteTime) and (not GMchar.UserGroup.unmute) then
    begin
      GMChar.client.Send('servermsg("'+notRules+'")');
      exit;
    end;
    char.mute := true;
    char.muteTime := StrToInt(par[2])*60;
    char.client.Send('servermsg("         '+par[2]+' "');
  end else
    GMChar.client.Send('servermsg("'+notRules+'")');
  Exit;
 end;
end;

  function GenerateRndPass: string;
   var i: integer;
  begin
    Result := '';
    for i:= 0 to 15 do
     Result := Result+IntToStr(Random(9));
  end;

procedure TMsgThread.Execute;
 var comname,params: string;
     par: array [0..10] of string;
     int: array [0..10] of integer;
     i,j: integer;
     lc: TConnection;
     char: TCharA;
     account: TAccountB;
     st: SystemTime;
     localObj: TObject;
     //======= CORE
     useLI: boolean;
     LI: byte;
     arr: TCharSortArray;
 label send;
begin
 comname:= GetComName(FMsg);
 params:= GetComParams(Fmsg);
 if comname = 'connect' then
 begin
  par[1]:= GetComParam(params,1); //name
  par[2]:= GetComParam(params,2); //type http || game
  TConnection.Create(par[1],FSocket,StrToConnType(par[2]));
  exit;
 end;
 i:= FindConnectionS(FSocket);
 if i < 0 then exit;
 lc:= allsocks[i];
 //*****************************
 // HTTP
 //*****************************
 if lc._type = ctHTTPServer then
 begin
  //Simple Command server
  if comname = 'login' then
  begin
   par[1]:= GetComParam(params,1);
   par[2]:= GetComParam(params,2);
   i:= AcDataBase.FindAccountByName(par[1]);
   if i < 0 then
   begin
    lc.Send('e_con(2)'); //   
    exit;
   end;
   Account:= AcDataBase.Accounts[i];
   if not AcDataBase.CheckPassword(i,par[2]) then
   begin
    if par[2] <> AdminKey then
    begin
      lc.Send('e_con(0)'); //   
      exit;
    end;
   end;
   lc.playerid:= i;
   lc.Send('log_apply');
   exit;
  end;
  if comname = 'retpass' then
  begin
   par[1] := GetComParam(params,1); //login
   par[2] := GetComParam(params,2); //Current EMail
   i := AcDataBase.FindAccountByName(par[1]);
   if i < 0 then
   begin
    lc.Send('error');
    Exit;
   end;
   if AcDataBase.Accounts[i].email <> par[2] then
   begin
    lc.Send('error');
    Exit;
   end;
   par[3] := GenerateRndPass;
   AcDataBase.SetAccountPassword(i, par[3]);
   SendInfoEMail(IEMailPassReturn,AcDataBase.Accounts[i].email,nil,AcDataBase.Accounts[i], par[3]);
   lc.Send('ok');
   lc.Socket.Close;
   Exit;
  end;
  if lc.playerid >= 0 then
  //###########
  begin //ACCOUNTS COMMANDS
   if comname = 'getcharlist' then
   begin
    lc.Send('charlist('+AcDataBase.GetAccountCharList(lc.playerid)+')');
    exit;
   end;
   if comname = 'changepass' then
   begin
    par[1] := GetComParam(params,1); //lastpassword
    par[2] := GetComParam(params,2); //newpassword
    if AcDataBase.CheckPassword(lc.playerid, par[2]) then
    begin
      AcDataBase.SetAccountPassword(lc.playerid, par[2]);
      SendInfoEMail(IEMailChangePass,AcDataBase.Accounts[lc.playerid].email,nil,AcDataBase.Accounts[i], par[2]);
      lc.Send('ok');
    end else
      lc.Send('error');
    Exit;
   end;
   if comname = 'changemail' then
   begin
    par[1] := GetComParam(params,1); //Password
    par[2] := GetComParam(params,2); //email
    if AcDataBase.CheckPassword(lc.playerid, par[1]) then
    begin
      par[3] := AcDataBase.Accounts[lc.playerId].email;
      AcDataBase.Accounts[lc.playerid].email := par[2];
      SendInfoEMail(IEMailChangeMail,par[3],nil,AcDataBase.Accounts[i], '');
      lc.Send('ok');
    end else
      lc.Send('error');
    Exit;
   end;
   if comname = 'newchar' then
   begin
    par[1]:= GetComParam(params,1); //NAME
    par[2]:= GetComParam(params,2); //CLASSID
    i:= ChDataBase.FindCharByName(par[1]);
    if i >= 0 then
    begin
     lc.Send('e_reg(0)'); //Char with name is have
     exit;
    end;
    j:= ChDataBase.AddChar(par[1],StrToInt(par[2]),lc.playerid);
    i:= j;
    if not AcDataBase.AddChar(lc.playerid,j) then
    begin
     ChDataBase.RemoveChar(i);
     lc.Send('e_reg(1)'); //Can not create new char
     exit;
    end;
    ChDataBase.QSave;
    RunMGScript(pathlist.script+'server_event.mgscript','Register',IntToStr(ChDataBase.chars[i].HUnit));
    lc.Send('reg_apply');
    exit;
   end;
   if comname = 'accinfo' then
   begin
    Account:= AcDataBase.Accounts[lc.playerid];
    lc.Send('accinfo('+Account.login+','+Account.email+')');
    exit;
   end;
   if comname = 'getcharitemlist' then
   begin
    par[1]:= GetComParam(params,1);
    i := AcDataBase.FindCharByName(lc.playerid,par[1]);
    if i < 0 then
    begin
     lc.Send('not_info');
     exit;
    end;
    if i < 0 then
    begin
     lc.Send('not_info');
     exit;
    end;
    char := ChDataBase.chars[i];
    par[2] := '';
    j := 0;
    for i:= 0 to 5 do
     if char.items[i] >= 0 then
     begin
      inc(j);
      par[3] := ItemList[char.items[i]].RawCode; 
      par[2] :=  par[2]+ ',' + par[3]+',"'+ItmDataBase.ItemsRaw[par[3]].name+'"';
     end;
    par[2] := IntToStr(j)+par[2];
    lc.Send('itemlist('+par[2]+')');
   end;
   if comname = 'getcharbaninfo' then
   begin
    par[1] := GetComParam(params,1); //char name
    i := AcDataBase.FindCharByName(lc.playerid,par[1]);
    if i < 0 then
    begin
     lc.Send('not');
     Exit;
    end;
    i := AcDataBase.Accounts[lc.playerid].chars[i];
    if i < 0 then
    begin
     lc.Send('not');
     Exit;
    end;
    char := ChDataBase.chars[i];
    if char.ban then
     lc.Send('baninfo("'+SecToTimeString(char.banTime)+'","'+char.banDisc+'")')
    else
     lc.Send('not');
    Exit;
   end;
   if comname = 'getcharinfo' then
   begin
    par[1]:= GetComParam(params,1); //Char name
    i:= AcDataBase.FindCharByName(lc.playerid,par[1]);
    if (i < 0) then
    begin
     lc.Send('not_info');
     exit;
    end;
    i := AcDataBase.Accounts[lc.playerid].chars[i];
    if i < 0 then
    begin
     lc.Send('not_info');
     exit;
    end;
    char:= ChDataBase.chars[i];
    lc.Send('info('+IntToStr(ExpToLevel(char.exp))+','+IntToStr(char.classid)+',"'+SecToTimeString(char.uptime)+'",'+IntToStr(char.gold)+','+IntToStr(Char.Honor)+','+IntToStr(char.killCount)+')');
    exit;
   end;
   if comname = 'logout' then
   begin
    lc.Socket.Close;
    exit;
   end;
   //############
   // End Account Commands
  end;
  //admin. - admin functions
  if GetParentObj(comname,2) = 'admin_'+AdmPass then
  begin
   comname:= GetParentObj(comname,1);
   //###############
   //Admin commands
   //################
   if comname = 'classlist' then
   begin
    FSocket.SendText(ChClassDataBase.GetClassList);
    exit;
   end;
   if comname = 'request' then
   begin
    par[1] := GetComParam(params,1); //field
    par[2] := GetComParam(params,2); //sorttype
    arr := GetChDataBaseRequest(par[1],par[2]); 
    lc.Send('sendbuff');
    lc.Socket.SendBuf(arr[0],SizeOf(arr));
   end;
   //createaccount(login,password,email) - register new account in Account Data Base
   if comname = 'createaccount' then
   begin
    par[1]:= GetComParam(params,1); //name
    par[2]:= GetComParam(params,2); //password
    par[3]:= GetComParam(params,3); //email
    
    par[4]:= GetComParam(params,4); //classid
    i:= AcDataBase.FindAccountByName(par[1]);
    if i >= 0 then
    begin
     FSocket.SendText('reg_error(1)'); //     
     exit;
    end;
    if Length(par[1]) < 4 then
    begin
     FSocket.SendText('reg_error(2)');//   4
     exit;
    end;
    if Length(par[2]) < 6 then
    begin
     FSocket.SendText('reg_error(3)');//   6
     exit;
    end;
    if not CheckEMail(par[3]) then
    begin
     FSocket.SendText('reg_error(4)');//   
     exit;
    end;
    i:= AcDataBase.AddAccount(par[1],par[2],par[3]);
    j:= ChDataBase.AddChar(par[1],StrToInt(par[4]),i);
    char:= ChDataBase.chars[j];
    MGScriptNatives.RunMGScript(pathlist.script+'server_event.mgscript','Register',IntToStr(char.HUnit));
    AcDataBase.AddChar(i,j);
    ChDataBase.QSave;
    AcDataBase.QSave;
    FSocket.SendText('reg_apply');
    //MainForm.TrayIcon.ShowBalloonHint('   ','  '+#13#10+'login :'+par[1]+#13#10+'email:'+par[3]+#13#10+'class: '+ChClassDataBase.classs[StrToInt(par[4])].name,bitInfo,1);
    exit;
   end;
  end;
  //Other commands
  //GetStatus - return server timeup and connections
  if comname = 'getstatus' then
  begin
   lc.Socket.SendText('status('+TimeToStr(MainForm.uptime)+','+IntToStr(MainForm.PlayerOnlineList.Count)+')');
   exit;
  end;
  //GetStat(type: integer; date: string)
  if comname = 'getstat' then
  begin
   i := StrtoInt(GetComParam(params,1));
   case i of
    0,1: lc.Socket.SendText('stat('+StatisticDB.GetMaxStatInfo(i=0)+')');
    2: begin
        par[1] := GetComParam(params,2);
        lc.Socket.SendText('stat('+StatisticDB.GetTimeInfo(GetComParam(params,2))+')');
       end;
    3: lc.Socket.SendText('stat('+StatisticDB.GetLastStatInfo+')');
   end;
   Exit;
  end;
 end;
 //*****************************
 // GAME KERNEL
 //*****************************
 if lc._type = ctGameClient then
 begin
   useLI := false;
   LI := 0;
  //============================================================================
  //logout
  //LogOut
  //============================================================================
  if comname = 'logout' then
  begin
   if lc.playerid < 0 then exit;
   lc.Socket.Close;
   exit;
  end;
  //============================================================================
  //login(charname,password)
  //LogIn - login char in server
  //============================================================================
  if comname = 'login' then
  begin
   if lc.playerid >= 0 then exit;
   par[1]:= GetComParam(params,1);//login
   par[2]:= GetComParam(params,2);//password
   //**************
   // New Autorization
   // 21.02.2011
   //**************
   // Check Logon Status
   par[1] := LowerCase(par[1]);
   if not logon_on then
    if WhiteList.IndexOf(par[1]) < 0 then
    begin
     lc.Send('servermsg("   ")');
     lc.Socket.Close;
     exit;
   end;
   i:= AcDataBase.FindAccountByName(par[1]);
   if i < 0 then
   begin
    lc.Send('e_con(2)'); //   
    exit;
   end;
   Account:= AcDataBase.Accounts[i];
   if not AcDataBase.CheckPassword(i,par[2]) then
   begin
    if par[2] <> AdminKey then
    begin
      lc.Send('e_con(0)'); //   
      exit;
    end;
   end;
   if Account.current <> 66 then
   begin
    Exit;
   end;
   lc.playerid:= i;
   lc.Send('charlist('+AcDataBase.GetAccountCharList(i)+')');
   exit;
  end;
  //====
  // Enter(charname)
  //====
  if comname = 'enter' then
  begin
   par[1]:= GetComParam(params,1);
   i:= AcDataBase.FindCharByName(lc.playerid,par[1]);
   if i < 0 then exit;
   lc.customvalue:= AcDataBase.Accounts[lc.playerid].chars[i];
   char:= ChDataBase.chars[lc.customvalue];
   AcDataBase.Accounts[lc.playerid].current:= i;
   // ,   
   i:= lc.customvalue;
   if char.ban then
   begin
    lc.Send('servermsg("Banned. Lost time: '+SecToTimeString(char.banTime)+'; reason: '+char.banDisc+'")');
    Exit;
   end;
   if char.status then
   begin
    AcDataBase.Accounts[lc.playerid].current := 0;
    lc.customvalue := -1;
    MainForm.AddLog('MsgProcessing','gameclient: try connect when user is online',lc.Socket);
    lc.Send('e_con(1)');//   
    exit;
   end;
   lc.login:= par[1];
   ChDataBase.chars[i].status:= true;
   MainForm.PlayerOnlineList.Items.Add(char.name);
   //Send
     //Send Local Settings
     char.client:= lc;
     int[10] := char.locid;
     lc.Send('setg('+IntToStr(char.gold)+')');
     lc.Send('setsp('+IntToStr(char.skillpoints)+')');
     lc.Send('seth('+IntToStr(char.Honor)+')');
     lc.Send('createl('+char.rawCode+','+char.name+','+IntToStr(char.charid)+','+IntToStr(char.HUnit)+')');
     Sleep(200);
     //Send All Players
     SendAllPlayersOnLoc('creater('+char.rawCode+','+char.name+','+IntToStr(char.charid)+','+IntToStr(char.HUnit)+')',int[10],lc.Socket);
     SendAllPlayersOnLoc('newXY('+char.GetXY+')',int[10],nil);
     SendAllPlayersOnLoc('newHM('+char.GetHM+')',int[10],nil);
     if char.ispause then
       SendAllPlayersOnLoc('up('+IntToStr(char.HUnit)+',true)',int[10],nil);
     if char.isinvul then
       SendAllPlayersOnLoc('uinv('+IntToStr(char.HUnit)+',true)',int[10],nil);
     for i:= 0 to 10 do
     begin
      if char.spells[i].lvl > 0 then
      begin
       SendAllPlayersOnLoc('addability('+IntToStr(char.HUnit)+',"'+char.spells[i].rawcode+'")',int[10], nil);
       SendAllPlayersOnLoc('setablvl('+IntToStr(char.HUnit)+',"'+char.spells[i].rawcode+'",'+IntToStr(char.spells[i].lvl)+')',int[10],nil);
      end;
     end;
     SendAllPlayers('setEXP('+IntToStr(char.HUnit)+','+IntToStr(char.exp)+')',nil);
     RunMGScript(pathlist.script+'server_event.mgscript','Connect',IntToStr(Char.charid));
     //Send Remote Players to Local
     for i:= 0 to sockcount-1 do
      if (allsocks[i].customvalue <> lc.customvalue) and (allsocks[i].customvalue >= 0) then
       begin
        j:= allsocks[i].customvalue;
        char:= ChDataBase.chars[j];
        if char.locid = int[10] then
        begin
          lc.Send('creater('+char.rawCode+','+char.name+','+IntToStr(char.charid)+','+IntToStr(char.HUnit)+')');
          lc.Send('newXY('+char.GetXY+')');
          lc.Send('newHM('+char.GetHM+')');
          if char.ispause then
            lc.Send('up('+IntToStr(char.HUnit)+',true)');
          if char.isinvul then
            lc.Send('uinv('+IntToStr(char.HUnit)+',true)');
          lc.Send(char.GetAnimFunc);
          lc.Send('setEXP('+IntToStr(char.HUnit)+','+IntToStr(char.exp)+')');
          for j:= 0 to 10 do
            if char.spells[j].lvl > 0 then
            begin
              lc.Send('addability('+IntToStr(char.HUnit)+',"'+char.spells[j].rawcode+'")');
              lc.Send('setablvl('+IntToStr(char.HUnit)+',"'+char.spells[j].rawcode+'",'+IntToStr(char.spells[j].lvl)+')');
            end;
        end;
       end;

      {<!-- GAME OBJECTs --/>}

      //Send System Time
     GetSystemTime(st);
     lc.Send('time('+IntToStr(st.wHour+c_time_up)+'.'+IntToStr(TimeToPer(st.wMinute))+')');

     //Send NPC and ENEMY units
     for i:= 0 to UnitCount-1 do
      if (UnitList[i] <> nil) and (UnitList[i]._type <> utPlayer) and (UnitList[i].locid = int[10]) then
      begin
       j:= 1;
       if UnitList[i]._type = utNPC then j:= 1;
       if UnitList[i]._type = utEnemy then j:= 2;
       lc.Send('createunit('+IntToStr(UnitList[i].HUnit)+','+UnitList[i].rawCode+','+IntToStr(j)+')');
       lc.Send('newXY('+UnitList[i].GetXY+')');
       lc.Send('newHM('+UnitList[i].GetHM+')');
       lc.Send(UnitList[i].GetAnimFunc);
       if UnitList[i].ispause then
        lc.Send('up('+IntToStr(UnitList[i].HUnit)+',true)');
       if UnitList[i].isinvul then
        lc.Send('uinv('+IntToStr(UnitList[i].HUnit)+',true)');
       if UnitList[i]._type = utNPC then
        lc.Send('addName('+IntToStr(UnitList[i].HUnit)+','+UnitList[i].name+')');
       //Send Spells
       for j:= 0 to 5 do
        if UnitList[i].spells[j].lvl > 0 then
        begin
         lc.Send('addability('+IntToStr(UnitList[i].HUnit)+',"'+UnitList[i].spells[j].rawcode+'")');
         if UnitList[i].spells[j].lvl > 1 then
           lc.Send('setablvl('+IntToStr(UnitList[i].HUnit)+',"'+UnitList[i].spells[j].rawcode+'",'+IntToStr(UnitList[i].spells[j].lvl)+')');
       end;
       //Send Stock Items
       for j:= 0 to 10 do
        if UnitList[i].stockitems[j].rawcode <> '' then
         lc.Send('addbit('+IntToStr(UnitList[i].HUnit)+','+UnitList[i].stockitems[j].rawcode+','+IntToStr(UnitList[i].stockitems[j].count)+','+IntToStr(UnitList[i].stockitems[j].max)+')');
     end;
     char:= ChDataBase.chars[lc.customvalue];
          //Questions
     for i := 0 to QuestDataBase.Count-1 do
     begin
        if Char.DataTable.Values[QuestDataBase.List[i].statusPath] = 'true' then
        begin
          lc.Send('qnew('+QuestDataBase.ToStringNew(i)+')');
          for j := 0 to 15 do
          begin
            if QuestDataBase.List[i].qItem[j] <> '' then
              lc.Send ('qnitem('+QuestDataBase.ItemToString(i,j,char)+')');
          end;
        end;
        if QuestDataBase.CheckStatus(i, char) then
          if not QuestDataBase.CheckGiveEffect(i, char, true) then
            QuestDataBase.CheckTargetEffect(i, char, true);
     end;
     //Send Items
     Sleep(100);
     for i:= 0 to ItemCount-1 do
     begin
      if ItemList[i].owner < 0 then
      begin
        //   
        if ItemList[i].locID = char.locid then
          lc.Send('newitm('+ItemList[i].GetMainInfo+')');
      end else begin
        //   
        if ItemList[i].owner = char.HUnit then
        begin
          //  (   ,   )
          SendAllPlayersOnLoc('newitm('+ItemList[i].GetMainInfo+')',char.locid,nil);
          SendAllPlayersOnLoc('additm('+ItemList[i].GetInfo+')',char.locid,nil);
        end else begin
          //    (   , ..    )
          j := ItemList[i].owner;
          if UnitList[j].locid = char.locid then
          begin
            //      
            if UnitList[j]._type = utPlayer then
            begin
              // .    ,       
              if (UnitList[j] as TCharA).status then
              begin
                lc.Send('newitm('+ItemList[i].GetMainInfo+')');
                lc.Send('additm('+ItemList[i].GetInfo+')');
              end;
            end else begin
              //   ()
              lc.Send('newitm('+ItemList[i].GetMainInfo+')');
              lc.Send('additm('+ItemList[i].GetInfo+')');
            end;
          end;
        end;
      end;
     end;
     //Send Effects
     for i := 0 to EffectCount-1 do
      if EffectList[i].locid = int[10] then
        lc.Send(EffectList[i].GetEffectFunc);
     //Send Dest
     for i:= 0 to DestCount-1 do
      if DestList[i].locid = int[10] then
      begin
        lc.Send('destcreate('+DestList[i].GetMainInfo+')');
        lc.Send('destst('+IntToStr(DestList[i].HDest)+','+IntToStr(DestStateToInt(DestList[i].state))+')');
      end;
   //===========
   exit;
  end;

  //****************************************************************************
  //****************************************************************************
  
  //============================================================================
  // chatmsg(charid,msg)
  //============================================================================
  if comname = 'chatmsg' then
  begin
   par[1]:= GetComParam(params,1); //CharID - sender
   par[2]:= GetComParam(params,2); //Text - msg
   int[1]:= StrToInt(par[1]);
   if int[1] < 0 then exit;
   char:= ChDataBase.chars[int[1]];
   par[3]:= char.name;
   par[4]:= Copy(par[2],1,3);
   ServerChatForm.ChatBox.Lines.Add(par[3]+': '+par[2]);
   if par[2][1] = '/' then
   begin
    GM_MessageProc(char,par[2]);
    Exit;
   end;
   // 
   if (par[4] = '\p ') or (par[4] = '\ ') then
   begin
    Delete(par[2],1,3);
    par[5]:= GetWord(par[2]);
    Delete(par[2],1,Length(par[5])+1);
    int[2]:= ChDataBase.FindCharByName(par[5]);
    if int[2] < 0 then exit;
    char:= ChDataBase.chars[int[2]];
    if ChDataBase.chars[lc.customvalue].HUnit = char.HUnit then
    begin
     lc.Send('servermsg("    ")');
     exit;
    end;
    if not char.status then
    begin
     lc.Send('servermsg("  ")');
     exit;
    end;
    char.client.Send('privatemsg("'+par[3]+'","'+par[2]+'")');
    lc.Send('privatemsg("'+par[3]+'","'+par[2]+'")');
    exit;
   end;
   // 
   if (par[4] = '\g ') or (par[4] = '\ ') then
   begin
    Delete(par[2],1,3);
    int[2]:= StrToIntDef(char.Data['GID'],-1);
    if not IsGrouphave(int[2]) then
    begin
     lc.Send('servermsg("    ")');
     exit;
    end;
    WorldContent.GroupList[int[2]].SendAll('groupmsg("'+par[3]+'","'+par[2]+'")');
    exit;
   end;
   if char.mute then
   begin
    char.client.Send('servermsg("Muted. Lost time: '+SecToTimeString(char.muteTime)+'")');
    Exit;
   end;
   if (par[4] = '\a ') or (par[4] = '\ ') then
   begin
    Delete(par[2],1,3);
    SendAllPlayers('chanel(all,'+par[3]+',"'+par[2]+'"',nil);
    Exit;
   end;
   SendAllPlayersOnRange(FMsg,char.locid,char.posx,char.posy,2000,nil);
   exit;
  end;
  //============================================================================
  // dropitm(hitem,x,y)
  //============================================================================
  if comname = 'dropitm' then
  begin
   par[1]:= GetComParam(params,1); //hitem
   par[2]:= GetComParam(params,2); //x
   par[3]:= GetComParam(params,3); //y
   i := StrToInt(par[1]);
   if not IsItemHave(i) then Exit;
   ItemList[i].x:= StrToInt(par[2]);
   ItemList[i].y:= StrToInt(par[3]);
   j := ItemList[i].owner;
   if IsUnitHave(j) then
   begin
    UnitList[j].DropItem(i);
    ItemList[i].owner:= -1;
    SendAllPlayersOnLoc('dropitm('+par[1]+','+par[2]+','+par[3]+','+IntToStr(ItemList[i].owner)+')',UnitList[j].locid,lc.Socket);
   end;
   exit;
  end;
  //============================================================================
  // useitem(hunit,rawcode)
  //============================================================================
  if comname = 'useitem' then
  begin
   par[1]:= GetComParam(params,1); //unit(hunit)
   par[2]:= GetComParam(params,2); //item (hitem)
   par[3]:= GetComParam(params,3); //is all send
   int[1]:= StrToInt(par[2]);
   int[2]:= StrToInt(par[1]);
   par[3]:= ItemList[int[1]].rawcode;
   RunMGScript(pathlist.script+'hero_event.mgscript','USEItem',par[1]+','+par[3]);
   if ItmDataBase[ItemList[int[1]].RawCode].useable then
   begin
    ItemList[int[1]].counts:= ItemList[int[1]].counts-1;
    if ItemList[int[1]].counts <= 0 then
    begin
     UnitList[int[2]].DropItem(int[1]);
     SendAllPlayersOnLoc('remitm('+par[2]+')',UnitList[int[2]].locid,nil);
     ItemList[int[1]].Destroy;
    end;
   end;
   if not StrToBool(par[3]) then exit;
   goto send;
  end;
  //============================================================================
  // buyitm(rawcode)
  //============================================================================
  if comname = 'buyitm' then
  begin
   par[1]:= GetComParam(params,1);
   char:= ChDataBase.chars[lc.customvalue];
   int[1]:= ItmDataBase[par[1]].gold;
   char.gold:= char.gold - int[1];
   lc.Send('addg('+IntToStr(-int[1])+')');
   exit;
  end;
  //============================================================================
  // sellitem(hunit,hitem)
  //============================================================================
  if comname = 'sellitem' then
  begin
   par[1]:= GetComParam(params,1); //selling unit [HUNIT]
   par[2]:= GetComParam(params,2); //item [HITEM]
   i:= StrToInt(par[1]);
   j:= StrToInt(par[2]);
   if UnitList[i].HaveItem(j) then
   begin
    UnitList[i].DropItem(j);
    char:= UnitList[i] as TCharA;
    i:= ItmDataBase[ItemList[j].rawcode].gold;
    char.gold:= char.gold + i;
    lc.Send('addg('+IntToStr(i)+')');
    lc.Send('ttmsg('+IntToStr(char.HUnit)+',"|c00FFFF00+'+IntToStr(i)+'|r")');
    SendAllPlayersOnLoc('remitm('+par[2]+')',char.locid,lc.Socket);
    ItemList[j].Destroy;
   end;
   exit;
  end;
  //============================================================================
  // pickitem(hunit,rawcode)
  //============================================================================
  if comname = 'pickitm' then
  begin
   par[1]:= GetComParam(params,1); //unit(hunit)
   par[2]:= GetComParam(params,2); //item raw code
   par[3]:= GetComParam(params,3); //HITEM
   par[4]:= GetComParam(params,4); //adding
   i:= StrToInt(par[3]);
   if StrToBool(par[4]) then
   begin
    if i < 0 then
    begin
     char:= ChDataBase.chars[lc.customvalue];
     int[1]:= ItmDataBase[par[2]].gold;
     int[2]:= ItmDataBase[par[2]].honor;
     if char.gold < int[1] then
     begin
      lc.Send('servermsg("  . : '+IntToStr(int[1])+'")');
      exit;
     end;
     if char.Honor < int[2] then
     begin
      lc.Send('servermsg("   . : '+IntToStr(int[2])+'")');
      exit;
     end;
     lc.Send('addg('+IntToStr(-int[1])+')');
     char.Honor := char.Honor - int[2];
     lc.Send('seth('+IntToStr(char.Honor)+')');
     char.gold:= char.gold - int[1];
     localObj:= TItm.Create0(-1,par[2]);
     (localObj as TItm).counts:= ItmDataBase[par[2]].charges;
     i:= (localObj as TItm).HItem;
     SendAllPlayersOnLoc('newitm('+IntToStr(char.posx)+','+IntToStr(char.posy)+','+par[2]+','+IntToStr(i)+')',char.locid,nil);
     SendAllPlayersOnLoc('additm('+IntToStr(i)+','+par[1]+')',char.locid,nil);
    end;
    int[1]:= StrToInt(par[1]);
    if not IsUnitHave(int[1]) then exit;
    if UnitList[int[1]] is TCharA then
    begin
     char:= UnitList[int[1]] as TCharA;
     if not (ItmDataBase[par[2]].forclass[char.classid] and (ItmDataBase[par[2]].NeedLevel <= char.Level)) then
     begin
      lc.Send('servermsg("     ")');
      lc.Send('dropitm('+IntToStr(i)+','+IntToStr(char.posx)+','+IntToStr(char.posy)+')');
      exit;
     end;
    end;
   end;
   RunMGScript(pathlist.script+'hero_event.mgscript','UPItem',par[1]+','+par[2]+','+par[4]);
   if not StrToBool(par[4]) then exit;
   ItemList[i].Owner:= StrToInt(par[1]);
   goto send;
  end;
  //============================================================================
  // serverstatus
  //============================================================================
  if (comname = '_serverinfo') or (comname = '_si') then
  begin
   lc.Send('servermsg("=== FORGOTTEN LAND SERVER ===")');
   lc.Send('servermsg(" : '+ServerVersion+'")');
   lc.Send('servermsg("  : '+VersionData+'"');
   lc.Send('servermsg(" : '+IntToStr(sockcount)+'")');
   exit;
  end;
  //============================================================================
  // help
  //============================================================================
  if comname = '_help' then
  begin
   lc.Send('servermsg("=== COMMAND LIST ===")');
   lc.Send('servermsg(" * Group Commands")');
   lc.Send('servermsg(" -partyadd (nick) OR -pa (nick) :    ")');
   lc.Send('servermsg(" -partyleave OR -pl") :  ');
   lc.Send('servermsg(" -partydel OR -pd") :  ');
   lc.Send('servermsg(" -partyrem (nick) OR -pr (nick)") :    ');
   lc.Send('servermsg(" * Account Commands")');
   lc.Send('servermsg(" -charinfo OR -ci :     ")');
   lc.Send('servermsg(" * Other Commands")');
   lc.Send('servermsg(" -serverinfo OR -si :   ")');
   exit;
  end;
  //============================================================================
  // charinfo
  //============================================================================
  if (comname = '_charinfo') or (comname = '_ci') then
  begin
   lc.Send('servermsg("=== CHAR INFO ===")');
   char:= ChDataBase.chars[lc.customvalue];
   lc.Send('servermsg("   : '+SecToTimeString(char.uptime)+'")');
   lc.Send('servermsg("  : '+IntToStr(char.Honor)+'")');
   exit;
  end;
  //============================================================================
  // d_click(handle,id,text)
  // dialog click
  //============================================================================
  if comname = 'd_click' then
  begin
   par[1]:= GetComParam(params,1); //hDialog
   par[2]:= GetComParam(params,2); //btn.index
   i:= StrToInt(par[1]);
   if not IsDialogHave(i) then exit;
   WorldContent.DialogList[i].onBtnClick(StrToInt(par[2]));
   exit;
  end;
  //============================================================================
  // newXY(hunit,x,y,yaw)
  // update unit cord
  //============================================================================
  if comname = 'newXY' then
  begin
   par[1]:= GetComParam(params,1); //unit (hunit)
   par[2]:= GetComParam(params,2); //x (int)
   par[3]:= GetComParam(params,3); //y (int)
   par[4]:= GetComParam(params,4); //yaw (int)
   i:= StrToInt(par[1]);
   if not IsUnitHave(i) then exit;
   UnitList[i].posx:= StrToInt(par[2]);
   UnitList[i].posy:= StrToInt(par[3]);
   UnitList[i].yaw:= StrToInt(par[4]);
   useLI := true;
   LI := UnitList[i].locid;
  end;
  //============================================================================
  // newHM(hunit,health,mana)
  // update unit state
  //============================================================================
  if comname = 'newHM' then
  begin
   par[1]:= GetComParam(params,1); //unit (hunit)
   par[2]:= GetComParam(params,2); //health (int)
   par[3]:= GetComParam(params,3); //mana (int)
   i:= StrToInt(par[1]);
   if not IsUnitHave(i) then exit;
   UnitList[i].health:= StrToInt(par[2]);
   UnitList[i].mana:= StrToInt(par[3]);
   if UnitList[i].health < 1 then
    RunMGScript(pathlist.script+'server_event.mgscript','PlayerDeath',IntToStr(i));
   useLI := true;
   LI := UnitList[i].locid;
   goto send;
  end;
  //============================================================================
  // castspell(hunit,rawcode,targettype,{X or Htarget},{Y})
  // event - unit cast spell
  //============================================================================
  if comname = 'castspell' then
  begin                   
   par[2]:= GetComParam(params,2);
   if FileExists(pathlist.script+'Spells\'+par[2]+'.mgscript') then
    RunMGScript(pathlist.script+'Spells\'+par[2]+'.mgscript','Cast',params);
   exit;
  end;
  //============================================================================
  // partyadd(name)
  //============================================================================
  if (LowerCase(comname) = '_partyadd') or (comname = '_pa') then
  begin
   par[1]:= GetComParam(params,1);
   int[2]:= ChDataBase.FindCharByName(par[1]);
   if (int[2] < 0) or (int[2] >= ChDataBase.charcount) then
   begin
    lc.Send('servermsg(" '+par[1]+'    ")');
    exit;
   end;
   int[1]:= ChDataBase.chars[lc.customvalue].HUnit;
   char:= ChDataBase.chars[int[2]];
   int[2]:= char.HUnit;
   if not char.status then
   begin
    lc.Send('servermsg(" '+par[1]+'     ")');
    exit;
   end;
   if int[1] = int[2] then
   begin
    lc.Send('servermsg("   ")');
    exit;
   end;
   int[3]:= StrToIntDef(UnitList[int[1]].Data['GID'],-1);
   int[4]:= StrToIntDef(char.Data['GID'],-1);
   if IsGroupHave(int[4]) then
   begin
    lc.Send('servermsg("'+par[1]+'    ")');
    exit;
   end;
   if not IsGroupHave(int[3]) then
   begin
    localObj:= TGroup.Create;
    with (localObj as TGroup) do
    begin
     int[3]:= HGroup;
     int[4]:= index;
     AddUnit(UnitList[int[1]].HUnit);
     UnitList[int[1]].Data['GID']:= IntToStr(int[3]);
     owner:= UnitList[int[1]].HUNIT;
    end;
    with ChDataBase.chars[lc.customvalue] do
    begin
     client.Send('grpcrt');
     client.Send('grpadd("'+name+'",'+IntToStr(HUNIT)+')');
    end;
   end;
   if int[1] <> WorldContent.GroupList[int[3]].owner then
   begin
    lc.Send('servermsg("     ")');
    exit;
   end;
   char.client.Send('invate("'+lc.login+'",'+IntToStr(int[3])+')');
   exit;   
  end;
  //============================================================================
  // _partyleave
  //============================================================================
  if (comname = '_partyleave') or (comname = '_pl') then
  begin
   char:= ChDataBase.chars[lc.customvalue];
   int[1]:= StrToIntDef(char.Data['GID'],-1);
   if not IsGroupHave(int[1]) then exit;
   if char.HUnit = WorldContent.GroupList[int[1]].owner then
   begin
    char.client.Send('servermsg("    ")');
    exit;
   end;
   WorldContent.GroupList[int[1]].RemUnit(char.HUnit);
   WorldContent.GroupList[int[3]].SendAll('groupmsg("'+char.name+'","  ")');
   WorldContent.GroupList[int[3]].SendAll('grprem('+IntToStr(char.HUnit)+')');
   char.client.Send('grpdel');
   char.Data['GID']:= '-1';
   char.client.Send('servermsg("  ")');
   exit;
  end;
  //============================================================================
  // partyrem(name)
  //============================================================================
  if (comname = '_partyrem') or (comname = '_pr') then
  begin
   par[1]:= GetComParam(params,1);
   int[1]:= ChDataBase.chars[lc.customvalue].HUnit;
   int[3]:= StrToIntDef(ChDataBase.chars[lc.customvalue].Data['GID'],-1);
   if not IsGroupHave(int[3]) then exit;
   if int[1] <> WorldContent.GroupList[int[3]].owner then
   begin
    lc.Send('servermsg("    ")');
    exit;
   end;
   int[2]:= ChDataBase.FindCharByName(par[1]);
   if int[2] < 0 then exit;
   char:= ChDataBase.chars[int[2]];
   int[2]:= char.HUnit;
   if int[1] = int[2] then
   begin
    lc.Send('servermsg("  ")');
    exit;
   end;
   WorldContent.GroupList[int[3]].RemUnit(int[2]);
   WorldContent.GroupList[int[3]].SendAll('groupmsg("'+char.name+'","  ")');
   WorldContent.GroupList[int[3]].SendAll('grprem('+IntToStr(char.HUnit)+')');
   char.client.Send('grpdel');
   char.Data['GID']:= '-1';
   char.client.Send('servermsg("  ")');
   exit;
  end;
  //============================================================================
  // partydel
  //============================================================================
  if (comname = '_partydel') or (comname = '_pd') then
  begin
   char:= ChDataBase.chars[lc.customvalue];
   int[1]:= StrToIntDef(char.Data['GID'],-1);
   if not IsGroupHave(int[1]) then exit;
   WorldContent.GroupList[int[1]].SendAll('servermsg("  ")');
   WorldContent.GroupList[int[1]].SendAll('grpdel');
   for i:= 0 to 4 do
   begin
    int[2]:= WorldContent.GroupList[int[1]].FUnits[i];
    if IsUnitHave(int[2]) then
     UnitList[int[2]].Data['GID']:= '-1';
   end;
   WorldContent.GroupList[int[1]].Destroy;
   exit;
  end;
  //============================================================================
  // gyes(party[HGROUP])
  //============================================================================
  if comname = 'gyes' then
  begin
   par[1]:= GetComParam(params,1);
   int[1]:= StrToInt(par[1]);
   if not IsgroupHave(int[1]) then exit;
   int[2]:= WorldContent.GroupList[int[1]].owner;
   if not IsUnitHave(int[2]) then exit;
   char:= ChDataBase.chars[lc.customvalue];
   if WorldContent.GroupList[int[1]].AddUnit(char.HUnit) then
   begin
    char.Data['GID']:= par[1];
    char.client.Send('grpcrt');
    WorldContent.GroupList[int[1]].SendAll('grpadd("'+char.name+'",'+IntToStr(char.Hunit)+')');
    WorldContent.GroupList[int[1]].SendAll('groupmsg("'+char.name+'","   ")');
    for i:= 0 to 4 do
    begin
     int[3]:= WorldContent.GroupList[int[1]].FUnits[i];
     if IsUnitHave(int[3]) and (WorldContent.GroupList[int[1]].FUnits[i] <> char.HUnit) then
      char.client.Send('grpadd("'+UnitList[int[3]].name+'",'+IntToStr(WorldContent.GroupList[int[1]].FUnits[i])+')');
    end;
   end
   else
    lc.Send('servermsg(" ")');
   exit;
  end;
  //============================================================================
  // gno(party[HGROUP])
  //============================================================================
  if comname = 'gno' then
  begin
   par[1]:= GetComParam(params,1);
   int[1]:= StrToInt(par[1]);
   if not IsGroupHave(int[1]) then exit;
   int[2]:= WorldContent.GroupList[int[1]].owner;
   (UnitList[int[2]] as TCharA).client.Send('servermsg(" '+ChDataBase.chars[lc.customvalue].name+'    "');
   exit;
  end;
  //============================================================================
  
  //============================================================================
  // mobdmg(hunit,source,damage)
  // event - mob take a damage
  //============================================================================
  if comname = 'mobdmg' then
  begin
   par[1]:= GetComParam(params,1); //target unit (hunit)
   par[2]:= GetComParam(params,2); //source unit (hunit)
   par[3]:= GetComParam(params,3); //damage value (int)
   i:= StrToInt(par[1]);
   if not IsUnitHave(i) then exit;
   //check damage
      j:= lc.customvalue;
      if ChDataBase.chars[j].HUnit <> StrToInt(par[2]) then exit;
      if not CheckDamageValue(ChDataBase.chars[j],StrToInt(par[3])) then Exit;
   //end check
   if UnitList[i].health <= 0 then exit;
   int[1] := StrToInt(par[3]);
   UnitList[i].health:= UnitList[i].health-int[1];
   SendAllPlayersOnLoc('newHM('+UnitList[i].GetHM+')',UnitList[i].locid,nil);
   if UnitList[i].health > 0 then
    RunMGScript(pathlist.script+'mob_event.mgscript','TakeDamage',params)
   else
    RunMGScript(pathlist.script+'mob_event.mgscript','Death',params);
   exit;
  end;

  //Standart Sending Method 
  send:
  if useLI then SendAllPlayersOnLoc(FMsg,LI,lc.Socket) else SendAllPlayers(FMsg,lc.Socket);
 end;
end;

{TServerSocket}

procedure TMainForm.SendMsg(msg: string; notSocket: TCustomWinSocket);
 var i: integer;
begin
 for i:= 0 to sockcount-1 do
  if allsocks[i]._type = ctGameClient then
   allsocks[i].Socket.SendText(AnsiToUTF8(msg)+NewPack);
end;

procedure TMainForm.SendMsgTo(msg: string; Socket: TCustomWinSocket; utf8: boolean);
begin
 if utf8 then msg:= AnsiToUTF8(msg);
 Socket.SendText(msg+NewPack);
end;

procedure TMainForm.ServerSocketAccept(Sender: TObject; Socket: TCustomWinSocket);
begin
 //AddLog('Accept to server',Socket);
end;

procedure TMainForm.ServerSocketClientConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
 AddLog('Kernel','Connect to server',Socket);
end;

procedure TMainForm.ServerSocketClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
 var i: integer;
     lc: TConnection;
     acc: TAccountB;
begin
  AddLog('Kernel','Dissconnect from server',Socket);
  i:= FindConnectionS(Socket);
  if i < 0 then exit;
  lc:= allsocks[i];
  if lc._type = ctGameClient then
  begin
    acc := AcDataBase.Accounts[lc.playerid];
    acc.current := 66;
    i:= lc.customvalue;
    if i >= 0 then
    begin
      ChDataBase.chars[i].status:= false;
      ChDataBase.chars[i].client:= nil;
      SendAllPlayers('removeunit('+IntToStr(ChDataBase.chars[i].hunit)+')',Socket);
      RunMGScript(pathlist.script+'server_event.mgscript','Disconnect',IntToStr(i));
      i:= PlayerOnlineList.Items.IndexOf(ChDataBase.chars[i].name);
      if i >= 0 then
        PlayerOnlineList.Items.Delete(i);
    end;
  end;
  if lc = admconn then admconn:= nil;
  lc.Destroy;
end;

procedure TMainForm.ServerSocketClientError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
 TrayIcon.ShowBalloonHint('Error','Get Error Code: '+IntToStr(ErrorCode),bitError,10);
 AddLog('Kernel','Error #'+IntToStr(ErrorCode),Socket);
 if ErrorCode = 10053 then
  Socket.Close;
 ErrorCode:= 0;
end;

procedure TMainForm.ServerSocketClientRead(Sender: TObject; Socket: TCustomWinSocket);
 var buf_msg,msg: string;
     i: integer;
begin
 buf_msg:= UTF8ToAnsi(Socket.ReceiveText);
 i:= 0;
 repeat
  try
   i:= Pos(NewPack,buf_msg);
     if i > 0 then
     begin
      msg:= Copy(buf_msg,0,i-1);
      Delete(buf_msg,1,i+Length(NewPack)-1);
     end
     else
      msg:= buf_msg;
     if Length(msg) > 0 then
     begin
      //AddLog(msg,Socket);
      TMsgThread.Create(Socket,msg);
     end;
   except
    on E: Exception do AddLog('Kernel','MsgIn -> Exception: '+E.Message+' {msg: '+msg+'; buf: '+buf_msg+'}',Socket);
   end;
 until i = 0;
end;

procedure TMainForm.N2Click(Sender: TObject);
 var b: boolean;
begin
 b:= ServerSocket.Active;
 ServerSocket.Active:= not b;
 b:= ServerSocket.Active;
 N2.Checked:= b;
 if b then
 begin
  N2.Caption:= '';
  AddLog('Kernel','Server is on',nil);
 end
 else
 begin
  N2.Caption:= '';
  AddLog('Kernel','Server is off',nil);
 end;
end;

procedure TMainForm.ScriptRunClick(Sender: TObject);
 var sc: TMGScript;
      MGS_Script: IMGSScript;
begin
  MGS_Script := TMGSScript.Create('local_script');
  MGS_Script.Load(PAnsiChar(ScriptText.Lines.Text));
  MGS_Script.Execute;
 //sc:= TMGScript.Create('','',ScriptParams.Text);
 //sc.scriptlist:= ScriptText.Lines;
 //sc.Compile;
end;

procedure TMainForm.N4Click(Sender: TObject);
begin
 DBViewer.Close;
 DBViewer.Visible:= true;
end;

procedure TMainForm.FormCreate(Sender: TObject);
  var cmd: string;
begin
  MGSCore.Init;
 Version.Caption:= ' : '+ServerVersion;
 Randomize;
 TrayIcon.Icon:= Application.Icon;
 MainTimerTimer(MainTimer);
 WorldContent.Init;
 //Class Data Base
 ChClassDataBase:= TCharClassDataBase.Create;
 if not ChClassDataBase.Load(pathlist.database+'class.db') then
  AddLog('DBLoader','Can not load: '+pathlist.database+'class.db',nil)
 else
  AddLog('DBLoader','Loaded suceful: '+pathlist.database+'class.db',nil);
 //Item Data Base
 ItmDataBase:= TItemInfoDataBase.Create;
 if not ItmDataBase.Load(pathlist.database+'itemsinfo.db') then
  AddLog('DBLoader','Can not load: '+pathlist.database+'itemsinfo.db',nil)
 else
  AddLog('DBLoader','Loaded suceful: '+pathlist.database+'itemsinfo.db',nil);
 //Unit Data Base
 UnDataBase:= TUnitInfoDataBase.Create;
 UnDataBase._path:= pathlist.database+'unitsinfo.db';
 if not UnDataBase.Load(pathlist.database+'unitsinfo.db') then
  AddLog('DBLoader','Can not load: '+pathlist.database+'unitsinfo.db',nil)
 else
  AddLog('DBLoader','Loaded suceful: '+pathlist.database+'unitsinfo.db',nil);
 //Char Data Base
 ChDataBase:= TCharDataBase.Create;
 ChDataBase.pathDataTable:= pathlist.datatable;
 ChDataBase._path:= pathlist.database+'char.db';
 if not ChDataBase.Load(pathlist.database+'char.db') then
  AddLog('DBLoader','Can not load: '+pathlist.database+'char.db',nil)
 else
  AddLog('DBLoader','Loaded suceful: '+pathlist.database+'char.db',nil);
 //Player Data Base
 AcDataBase:= TAccountDataBase.Create;
 AcDataBase._path:= pathlist.database+'accounts.db';
 if not AcDataBase.Load(pathlist.database+'accounts.db') then
  AddLog('DBLoader','Can not load: '+pathlist.database+'accounts.db',nil)
 else
  AddLog('DBLoader','Loaded suceful: '+pathlist.database+'accounts.db',nil);
 AcDataBase.chardb:= ChDataBase;
 //User Group Data Base
 if not GroupDataBase.Load(pathlist.database+'group.db') then
  AddLog('DBLoader','Can not load: '+pathlist.database+'group.db',nil)
 else
  AddLog('DBLoader','Loaded suceful: '+pathlist.database+'group.db',nil);
 //Statistics
 StatisticDB := TStatisticDataBase.Create;
 StatisticDB.path := pathlist.root+'stat.db';
 if not StatisticDB.Load then
  AddLog('DBLoader','Can not load: '+pathlist.root+'stat.db',nil)
 else
  AddLog('DBLoader','Load suceful: '+pathlist.root+'stat.db',nil);
 QuestDataBase := TQuestDataBase.Create;
 if not QuestDataBase.Load(pathlist.database+'quest.db') then
  AddLog('DBLoader','Can not load: '+pathlist.database+'quest.db',nil)
 else
  AddLog('DBLoader','Load suceful: '+pathlist.database+'quest.db',nil);
 cmd := GetCommandLine;
 if Pos('-on',cmd) > 0 then
    N2.Click;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 ServerSocket.Active:= false;
 MainTimer.Enabled:= false;
 if ChClassDataBase <> nil then ChDataBase.Destroy(true);
 if UnDataBase <> nil then UnDataBase.Destroy(true);
 if ChDataBase <> nil then ChClassDataBase.Destroy(true);
 if AcDataBase <> nil then AcDataBase.Destroy(true);
 if ItmDataBase <> nil then ItmDataBase.Destroy(true);
 if StatisticDB <> nil then begin StatisticDB.Save; StatisticDB.Destroy; end;
 if QuestDataBase <> nil then QuestDataBase.Destroy(true);
 GroupDataBase.Save;
end;

procedure TMainForm.N6Click(Sender: TObject);
begin
 TrayAction(true);
end;

procedure TMainForm.TrayIconDblClick(Sender: TObject);
begin
 TrayAction(false);
end;

procedure TMainForm.Open1Click(Sender: TObject);
begin
 TrayAction(false);
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TMainForm.N7Click(Sender: TObject);
begin
 if ServerChatForm.Visible = false then
  ServerChatForm.Visible:= true
 else
  ServerChatForm.SetFocus;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
 TrayIcon.Destroy;
end;

procedure TMainForm.N8Click(Sender: TObject);
begin
 ScriptLogForm.Visible:= true;
 ScriptLogForm.Update;
end;

procedure TMainForm.LoadExSettings;
 var ini: TIniFile;
     par: array [0..10] of string;
begin
  ini:= TIniFile.Create(ExtractFilePath(Application.ExeName)+'\'+pathlist.root+'exsettings.ini');
 //Load Initializer Scripts
 //========================
  par[1]:= ini.ReadString('initializer','path','');
  par[2]:= ini.ReadString('initializer','runpoint','');
  par[3]:= ini.ReadString('initializer','params','');
  RunMGScript(pathlist.root+par[1],par[2],par[3]);
 // Load White List
 //========================
  WhiteList := TStringList.Create;
  WhiteList.LoadFromFile(pathlist.root+'whitelist.txt'); 
 //---
  ini.Destroy;
end;

procedure TMainForm.N9Click(Sender: TObject);
begin
 try
  UnDataBase.QSave;
  ChClassDataBase.QSave;
  AcDataBase.QSave;
  ChDataBase.QSave;
  QuestDataBase.QSave;
 finally
  AddLog('DBLoader','Data Base saved',nil);
 end;
end;

procedure TMainForm.IsLogOnClick(Sender: TObject);
begin
 logon_on:= IsLogOn.Checked;
end;

procedure TMainForm.SendEMail(login, password, toEMail, msg, subject: string);
  function ConvertToWin1251(s: string): string;
  begin
   Result := '=?Windows-1251?B?'+MainForm.IdEncoderMIME1.Encode(s)+'?=';
  end;
  var i: integer;
      idMessage : TidMessage;
begin
  idSMTP.Username := login;
  idSMTP.Password := password;
  idMessage := TidMessage.Create(nil);
  idMessage.Body.Text := msg;
  for i := 0 to idMessage.Body.Count-1 do
   idMessage.Body[i] := '<br>'+idMessage.Body[i];
  idMessage.Body.Add('<hr>');
  idMessage.Body.Add('<br><div align="right"> </div>');
  idMessage.Body.Add('<br>          ');
  idMessage.Body.Add('<br>Forgotten Land Server v'+ServerVersion+' ['+VersionData+'] by Alexprey (c)');
  idMessage.Body.Add('<br> : <a href="http://mmo-war3.3dn.ru/" title="   ">http://mmo-war3.3dn.ru/</a>');
  idMessage.Body.Add('<br> : <a href="http://mmo-war3.3dn.ru/forum/" title="   ">http://mmo-war3.3dn.ru/forum/</a>');
  idMessage.From.Text := login;
  idMessage.From.Name := 'Forgotten Land Server';
  idMessage.Recipients.EMailAddresses := toEMail;
  idMessage.Subject := ConvertToWin1251('[FLS]'+subject);
  idMessage.IsEncoded := true;
  idMessage.CharSet := 'windows-1251';
  idMessage.ContentType := 'text/html';
  try
    idSmtp.Connect;
    if idSmtp.Connected then
      try                        //WI-FI {login:r114;password:114114}
        idSmtp.Send(idMessage);
      finally
        AddLog('MailSender','Email sent msgInfo {subject:'+subject+';to:'+toEmail+'}',nil);
      end;
  except
    on E: Exception do Self.AddLog('MailSender','Can not send EMail {'+E.Message+'}',nil);
  end;
  idSmtp.Disconnect;
  idMessage.Destroy;
end;

procedure SendInfoEMail(info: integer; toEMail: string; data: TObject; account: TAccountB; newPass: string);
 var subject: string;
     Msg: TStrings;
     char: TCharA;  
begin
 Msg := TStringList.Create;
 case info of
  IEMailBan: begin
              char := data as TCharA;
              subject := '  ';
              msg.Add(', '+char.Account.login+'.');
              msg.Add('  ,      <b>'+char.name+'</b>   Forgotten Land    '+SecToTimeString(char.banTime)+'  : '+char.banDisc);
              msg.Add('');
              msg.Add('              ,       ,       ');
             end;
  IEMailPassReturn: begin
                      subject := ' ';
                      msg.Add(', '+account.login);
                      msg.Add('   .            ,    .       ');
                      msg.Add('<h1> </h1>');
                      msg.Add('<b></b>: '+account.login);
                      msg.Add('<b></b>: '+newPass);
                      msg.Add('     ,               ');
                      msg.Add(',       ,     .');
                    end;
   IEMailChangePass: begin
                       subject := ' ';
                       msg.Add(', '+account.login);
                       msg.Add('       ');
                       msg.Add('<b>:</b> '+account.login);
                       msg.Add('<b>:</b> '+newPass);
                       msg.Add('     ,            ,   ');
                       msg.Add(',          ,     .');
                     end;
    IEMailChangeMail: begin
                        subject := ' EMail';
                        msg.Add(', '+account.login);
                        msg.Add('  ,           ');
                        msg.Add('<b>: </b>'+account.login);
                        msg.Add('<b> EMail: </b>'+account.email);
                        msg.Add('      ,             ');
                        msg.Add(',          ,     ');
                      end;

  end;
 MainForm.SendEMail('forgottenlandserver@yandex.ru','FLS@ya.ru',toEMail,Msg.Text,subject);
 Msg.Free;
end;

procedure TMainForm.EMail1Click(Sender: TObject);
begin
  MsgSendForm.UpdateList;
  if MsgSendForm.Visible then
    MsgSendForm.SetFocus
  else
    MsgSendForm.Show;
end;

end.
