unit jass_types;

interface

type
	Jass_integer = LongInt;
	Jass_real = PSingle;
	Jass_boolean = LongInt;
	Jass_handle = record
		handleID: LongInt;
	end;
	Jass_code = LongInt;
	Jass_string = LongInt;

	Jass_event = Jass_handle;
	Jass_player = Jass_handle;
	Jass_widget = Jass_handle;
	Jass_unit = Jass_widget;
	Jass_destructable = Jass_widget;
	Jass_item = Jass_widget;
	Jass_ability = Jass_handle;
	Jass_buff = Jass_ability;
	Jass_force = Jass_handle;
	Jass_group = Jass_handle;
	Jass_trigger = Jass_handle;
	Jass_triggercondition = Jass_handle;
	Jass_triggeraction = Jass_handle;
	Jass_timer = Jass_handle;
	Jass_location = Jass_handle;
	Jass_region = Jass_handle;
	Jass_rect = Jass_handle;
	Jass_boolexpr = Jass_handle;
	Jass_sound = Jass_handle;
	Jass_conditionfunc = Jass_boolexpr;
	Jass_filterfunc = Jass_boolexpr;
	Jass_unitpool = Jass_handle;
	Jass_itempool = Jass_handle;
	Jass_race = Jass_handle;
	Jass_alliancetype = Jass_handle;
	Jass_racepreference = Jass_handle;
	Jass_gamestate = Jass_handle;
	Jass_igamestate = Jass_gamestate;
	Jass_fgamestate = Jass_gamestate;
	Jass_playerstate = Jass_handle;
	Jass_playerscore = Jass_handle;
	Jass_playergameresult = Jass_handle;
	Jass_unitstate = Jass_handle;
	Jass_aidifficulty = Jass_handle;
	Jass_eventid = Jass_handle;
	Jass_gameevent = Jass_eventid;
	Jass_playerevent = Jass_eventid;
	Jass_playerunitevent = Jass_eventid;
	Jass_unitevent = Jass_eventid;
	Jass_limitop = Jass_eventid;
	Jass_widgetevent = Jass_eventid;
	Jass_dialogevent = Jass_eventid;
	Jass_unittype = Jass_handle;
	Jass_gamespeed = Jass_handle;
	Jass_gamedifficulty = Jass_handle;
	Jass_gametype = Jass_handle;
	Jass_mapflag = Jass_handle;
	Jass_mapvisibility = Jass_handle;
	Jass_mapsetting = Jass_handle;
	Jass_mapdensity = Jass_handle;
	Jass_mapcontrol = Jass_handle;
	Jass_playerslotstate = Jass_handle;
	Jass_volumegroup = Jass_handle;
	Jass_camerafield = Jass_handle;
	Jass_camerasetup = Jass_handle;
	Jass_playercolor = Jass_handle;
	Jass_placement = Jass_handle;
	Jass_startlocprio = Jass_handle;
	Jass_raritycontrol = Jass_handle;
	Jass_blendmode = Jass_handle;
	Jass_texmapflags = Jass_handle;
	Jass_effect = Jass_handle;
	Jass_effecttype = Jass_handle;
	Jass_weathereffect = Jass_handle;
	Jass_terraindeformation = Jass_handle;
	Jass_fogstate = Jass_handle;
	Jass_fogmodifier = Jass_handle;
	Jass_dialog = Jass_handle;
	Jass_button = Jass_handle;
	Jass_quest = Jass_handle;
	Jass_questitem = Jass_handle;
	Jass_defeatcondition = Jass_handle;
	Jass_timerdialog = Jass_handle;
	Jass_leaderboard = Jass_handle;
	Jass_multiboard = Jass_handle;
	Jass_multiboarditem = Jass_handle;
	Jass_trackable = Jass_handle;
	Jass_gamecache = Jass_handle;
	Jass_version = Jass_handle;
	Jass_itemtype = Jass_handle;
	Jass_texttag = Jass_handle;
	Jass_attacktype = Jass_handle;
	Jass_damagetype = Jass_handle;
	Jass_weapontype = Jass_handle;
	Jass_soundtype = Jass_handle;
	Jass_lightning = Jass_handle;
	Jass_pathingtype = Jass_handle;
	Jass_image = Jass_handle;
	Jass_ubersplat = Jass_handle;

implementation

end.
